' Lista de comandos para utilizar el MOUSE en TurboBAsic(R)
' (c) Antoni Aloy Lpez
' Hostal, 2 - A
' 07400 - Alcdia
' 5 de febrer de 1992
'
' Este archivo consta de las siguientes subrutinas en TurboBasic(R):
	'
	' test		Mira si hay un mouse instalado
	' activa	Activa el mouse
	' desactiva	Desactiva el mouse
	' estado	Da informacin sobre localizacin y botn pulsado
	' fija 		Fija la posicin de mouse
	' botop		Informacin sobre pulsaciones
	' botoa		Informacin sobre liberacin de pulsacin
	' ventana 	Define una ventana por la que podr moverse el mouse
	' movimiento    Informa si el mouse se ha movido
	' elige  	Elige entre el tipo de cursor de texto i lo configura
	'
'
' Nota: No se dan garantias sobre el funcionamiento de estas rutinas en un
' sistema determinado. El autor elude toda responsabilidad sobre la utiliza
' cin que se haga de ellas. Totes les rutines han sido probadas empleando
' el mouse de GENIUS(R) en un monitor monocromo. En principio deben ser-
' vir para otros modelos y marcas pero nunca se sabe...
'
' Puede incluir estas rutinas en sus programas que vayan a utilizarlas simple
' mente haciendo uso del metacomando $include. Es decir en la cabecera del
' programa debera escribir $include "mouse.bas".
'
' Puede encontrar ms informacin en la documentacion que acompaa a su ratn
' (normalmente se trata de un archivo en disco), en el manual del programa
' TurboBaic en lo que hace referencia a la utilizacin de registros e interrup
' ciones i en cualquier libro de leguaje ensamblador (les recomiendo el libro
' de Miguel Angel Rodrguez que edita ANAYA).
'
' ===========================================================================
'	
sub test(t%,nb%)
	' Mira si el mouse est instalado devuelve
	'	t% = -1 si est instalado
	'	   = 0  si no lo est
	'	nb% = nmero de botones del MOUSE
	reg 1,0
	call interrupt 51
	t%=reg(1)
	nb%=reg(2)
end sub


sub activa
	reg 1,1
	call interrupt 51
end sub

sub desactiva
	reg 1,2
	call interrupt 51
end sub

sub estado(fila%,columna%,boto%)
	' devuleve el estatus del MOUSE: su posicin en la pantalla en
	' fila%,columna% (modo texto 80 columnas 25 filas) i el botn que
	' est pulsado actualmente, 1 para el botn izquierdo,
	' 2 para el derecho i 4 para el botn medio.
	reg 1,3
	call interrupt 51
	fila% = reg(4)/8+1
	columna% = reg(3)/8+1
	boto% = reg(2)
end sub

sub fija(fila%,columna%)
	' Fija la nueva posicin del cursor del MOUSE
	reg 1,4
	reg 3,(columna%-1)*8
	reg 4,(fila%-1)*8
	call interrupt 51
end sub

sub botop (quin%,np%,fila%,columna%)
	' Esta rutina nos informa del estado de un botn especfico del
	' mouse, que deberemos indicar en el parmetro quin%, nos devuelve
	' en np% el nmero de pulsaciones del MOUSE desde la ltima llamada
	' a la funcin, as como la posicin (fila%,columna%) del MOUSE.
	' i dentro de quin% el estado del botn pulsado.
	' El valor a introducir en quin% y que devuelve corresponden a:
	' 1 para el botn izquierdo
	' 2 para el botn derecho
	' 4 para el botn medio (MOUSE con tres botones)
	reg 1,5
	reg 2,quin%
	call interrupt 51
	quin% = reg(1)
	np% = reg(2)
	columna% = reg(3)/8+1
	fila% = reg(4)/8 +1
end sub

sub botoa (quin%,np%,fila%,columna%)
	' Esta rutina es similar a la anterior excepto que nos da el nmero
	' de veces que se liber el ratn desde la ltima vez que se llam.
	reg 1,6
	reg 2,quin%
	call interrupt 51
	quin% = reg(1)
	np% = reg(2)
	columna% = reg(3)/8+1
	fila% = reg(4)/8 +1
end sub

sub ventana(filas%,columnas%,filai%,columnai%)
	' Esta rutina establece una ventana en la la que puede moverse
	' el cursor del ratn.
	reg 1,7
	reg 3,(columnas%-1)*8
	reg 4,(columnai%-1)*8
	call interrupt 51
	reg 1,8
	reg 3,(filas%-1)*8
	reg 4,(filai%-1)*8
	call interrupt 51
end sub

sub movimiento(hor%,ver%)
	' Esta subrutina nos da el desplazamiento de MOUSE desde la
	' ltima vez que se llam a la funcin. Un valor positivo de hor%
	' indica movimiento hacia la derecha y uno negativo hacia la
	' izquierda. Un movimiento positivo de ver% indica movimiento hacia
	' abajo y uno negativo hacia arriba.
	hor% =0
	ver% = 0
	reg 1,11
	call interrupt 51
	hor% = reg(3)
	ver% = reg(4)
end sub

sub elige (cual%,emp%,acaba%)
	' Elige entre el cursor hardware o sotware del mouse
	' los parmetros pueden tomar valores entre 0 y 7 para monitores a
	' color y entre 0 y 11 para monitores monocromos. (emp%,acaba%)
	' el parmetro cual% es el que determina el tipo de cursor:
		'	1 ------> cursor hardware
		'	0 ------> cursor software
	' En el caso del cursor hardware emp% y acaba% determinan las lneas
	' de definicion del cursor; en el caso de cursor software determinan
	' los atributos y el cdigo de carcter del cursor. Los parmetros se
	' deben pasar en hexadeximal. &H____. Las dos primeras posiciones de
	' cual indican el atributo, pudindose llenar las dos ltimas con
	' ceros. Las dos primeras posiciones de acaba% inican el atributo
	' de carcter y las dos ltimas el carcter.
	' Ejemplos:
  ' call elige (0,&H7700,&H772A) Escribe un arterisco en la pantalla
	'	 		 en video inverso.
  ' call elige (0,&H7700,&H002A) Escribe el arterisco en modo normal
  ' call elige (0,&H7700,&H001E) Escribe un tringulo en modo normal
	'
	' Para un monitor monocromo los cdigos de atributo son:
	'	07	Normal (blanco sobre negro)
	'	70	Video inverso
	'	01	Subrayado
	'	00	Invisible (negro)
	'	77	Invisible (blanco)
	
	reg 1,10
	reg 2,cual%
	reg 3,emp%
	reg 4,acaba%
	call interrupt 51
end sub
