;Procedimientos tiles para programas en Assembler.
;Llamarlas con Include RSL.PRO al principio del programa.
;Para utilizar conjuntamente con RSL.MAC y RSL.CON.


;Procedimiento: WorDec
;Hace:          Convierte un Word ASCII en un nmero decimal.
;Parmetros:    Ign16: Word ASCII.
;Retorna:       Resu: Nmero decimal.

WorDec  PROC Far
        Push AX
        Push CX
        Push DX
        Push SI
        Push DI
        Mov AX,Ing16
        Mov SI,10
        Xor CX,CX
WorDec1:
        Xor DX,DX
        Div SI
        Push DX
        Inc CX
        Or AX,AX
        Jne WorDec1
        Xor DI,DI               ;Preparacin para NibHex
WorDec2:
        Pop DX
        Call NibHex
        Loop WorDec2
        Mov Resu[DI],0          ;Postpreparatorio para NibHex
        Pop DI
        Pop SI
        Pop DX
        Pop CX
        Pop AX
        Ret
WorDec  ENDP

;Procedimiento: NibHex
;Hace:          Convierte un Nibble ASCII en un nmero hexadecimal/decimal en
;               formato numrico para poder ser impreso
;Parmetros:    Pasados por WorHex/BytHex.
;Retorna:       Retornados a WorHex/BytHex.

NibHex  PROC Far
        Push DX
        Cmp DL,10
        Jae NibHex1
        Add DL,'0'
        Jmp Short NibHex2
NibHex1:
        Add DL,'A'-10
NibHex2:
        Mov Resu[DI],DL
        Inc DI
        Pop DX
        Ret
NibHex  ENDP


;Procedimiento: InNum
;Hace:          Se obtiene del teclado un nmero de como mximo MaxDigits que
;               estarn comprendidos entre Min y Max ambos incluidos.
;Parmetros:    Min, Max, MaxDigits.
;Retorna:       En AX el nmero entrado.
InNum   PROC Far
        Push CX
        Push DX
        Push DI

        Xor BL,BL
        Xor SI,SI
InNum1: Xor AH,AH               ;Obtiene carter del teclado
        Int 16h
        Or SI,SI
InNum2: Cmp AL,13               ;Es Return?
        Jz InNum5
        Cmp BL,MaxDigits        ;Comprueba el lmite de dgitos
        Jz InNum1
InNum3: Cmp AL,Min              ;Comprueba que el carcter est
        Jl InNum1               ;comprendido entre Min y Max
        Cmp AL,Max
        Jg InNum1
        Inc BL                  ;Incrementa el nmero de dgitos
InNum4: Mov Numero[SI],AL       ;Guarda el carcter en la memoria
        Inc SI
        Mov AH,2                ;Escribe el carcter
        Mov DL,AL
        Int 21H
        Jmp InNum1
          
InNum5: Or BL,BL                ;Mira si hay ms dgitos
        Jz InNum1
        Xor AX,AX
        Xor BX,BX
        Mov DI,10
        Mov CX,SI
        Xor SI,SI

InNum6: Mul DI                  ;Multiplica AX por 10
InNum7: Mov BL,Numero[SI]       ;cogiendo el dgito de la memoria
        Sub BL,'0'
        Add AX,BX               ;Lo suma a AX
        Inc SI                  ;Otro dgito
        Loop InNum6


InNum8: Pop DI
        Pop DX
        Pop CX

        Ret                     ;AX contiene el nmero binario.
InNum   ENDP
