#include <graphics.h>
#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <math.h>
#include <time.h>
#include <dos.h>

#define PI 3.141592654

void grafics (void);
void sortir (int e);
void info (void);
void menu (void);
void ferlinea (void);
void ferarc (void);
void fercercle (void);
void ferelipse (void);
void ferpoligonireg (void);
void ferpoligonreg (void);
void ferrectangle (void);
void cursors (int *, int *);
void estat (char *);
void numero (int *, int, int);


void main (void)
{
	grafics();
	menu();
	sortir(0);
}

void grafics (void)
{
	int driver, mode;

	detectgraph (&driver, &mode);
	if (graphresult()!=grOk)
		sortir(1);
	initgraph (&driver, &mode, "");
}

void sortir (int e)
{
	closegraph();
	if (e==0)
		puts("Tot de guais!");

	else if (e==1)
		puts("Error(%01): Al inicializar grficos.");

	if (e!=0)
	{
		puts("Pulsa una tecla...");
		getch();
	}
	exit(e);
}

void info (void)
{
	setcolor(1);
	setfillstyle(SOLID_FILL, 1);
	bar(100, 100, getmaxx()-100, getmaxy()-100);
	setcolor(0);
	rectangle(99, 99, getmaxx()+101, getmaxy()+101);
	rectangle(98, 98, getmaxx()-102, getmaxy()-102);
	rectangle(97, 97, getmaxx()-103, getmaxy()-103);

	getch();
}


void menu (void)
{
	char tecla;

	settextstyle(DEFAULT_FONT, HORIZ_DIR, 1);
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 0, getmaxx(), getmaxy());
	//info();
	do
	{
		setcolor(1);
		setfillstyle(SOLID_FILL, 1);
		bar(0, getmaxy()-8, getmaxx(), getmaxy());
		setcolor(7);
		outtextxy(0, getmaxy()-8, "[Linia] [Arc] [Circumferencia] [Poligon Regular] [El.lipse] [Rectangle] [Sortir]");
		setcolor(15);
		outtextxy(0, getmaxy()-8, " L       A     C                P                 E          R           S");
		tecla=toupper(getch());
		if (tecla=='L')
			ferlinea();
		else if (tecla=='A')
			ferarc();
		else if (tecla=='C')
			fercercle();
		else if (tecla=='P')
			ferpoligonreg();
		else if (tecla=='E')
			ferelipse();
		else if (tecla=='R')
			ferrectangle();
	}
	while (tecla!='S');
}


void ferlinea (void)
{
	int x1, y1, x2, y2;

	estat("[Linea]. Selecciona amb cursors el primer punt, i ENTER per confirmar");
	cursors(&x1, &y1);
	putpixel(x1, y1, 12);
	estat("[Linea]. Selecciona amb cursors el segon punt, i ENTER per confirmar");
	cursors(&x2, &y2);
	putpixel(x2, y2, 12);
	setcolor(0);
	line (x1, y1, x2, y2);
}

void ferarc (void)
{
	int x1, y1, x2, y2, s1, s2, r;

	estat("[Arc]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursors(&x1, &y1);
	putpixel(x1, y1, 12);
	estat("[Arc]. Selecciona amb cursors el radi, i ENTER per confirmar");
	cursors(&x2, &y2);
	putpixel(x2, y2, 12);
	estat("[Arc]. Entra el primer angle...");
	numero(&s1, 0, 360);
	estat("[Arc]. Entra el segon angle...");
	numero(&s2, 0, 360);
	setcolor(0);
	r=max(abs(y2-y1), abs(x2-x1));
	arc(x1, y1, min(s1, s2), max(s1, s2), r);
}

void fercercle (void)
{
	int x1, y1, x2, y2, r;

	estat("[Cercle]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursors(&x1, &y1);
	putpixel(x1, y1, 12);
	estat("[Cercle]. Selecciona amb cursors el radi, i ENTER per confirmar");
	cursors(&x2, &y2);
	putpixel(x2, y2, 12);
	setcolor(0);
	r=max(abs(y2-y1), abs(x2-x1));
	circle(x1, y1, r);
}

void ferelipse (void)
{
	int x1, y1, x2, y2, x3, y3, rx, ry;

	estat("[El.lipse]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursors(&x1, &y1);
	putpixel(x1, y1, 12);
	estat("[El.lipse]. Selecciona amb cursors el radi, i ENTER per confirmar");
	cursors(&x2, &y2);
	putpixel(x2, y2, 12);
	setcolor(0);
	rx=abs(x2-x1);
	ry=abs(y2-y1);
	ellipse(x1, y1, 0, 360, rx, ry);
}


void ferpoligonreg (void)
{
	int i;
	int x1, y1, x2, y2, r, n, tmpx, tmpy;
	float angle;
	int poligon[40];

	estat("[PoligonReg]. Selecciona amb cursors el vertex, i ENTER per confirmar");
	cursors(&x1, &y1);
	putpixel(x1, y1, 12);
	estat("[PoligonReg]. Selecciona amb cursors el radi, i ENTER per confirmar");
	cursors(&x2, &y2);
	putpixel(x2, y2, 12);

	estat("[PoligonReg]. Entra el nmero de costats...");
	numero(&n, 3, 20);

	r=max(abs(y2-y1), abs(x2-x1));
	angle=(360/n)*PI/180;
	tmpx=x1;
	tmpy=y1;
	for (i=1; i<=n; i++)
	{
		poligon[i*2]=(tmpx-x1)*cos(angle)+(tmpy-y1)*(-sin(angle));
		poligon[i*2+1]=(tmpy-y1)*sin(angle)+(tmpx-x1)*cos(angle);
		tmpx=poligon[i*2];
		tmpy=poligon[i*2+1];
	}
	setcolor(0);
	drawpoly(n, poligon);
}

void ferpoligonireg (void)
{
}

void ferrectangle (void)
{
	int x1, y1, x2, y2;

	estat("[Rectangle]. Selecciona amb cursors el primer punt, pitja ENTER per confirmar");
	cursors(&x1, &y1);
	putpixel(x1, y1, 12);
	setcolor(1);
	setfillstyle(SOLID_FILL, 1);
	bar(0, getmaxy()-8, getmaxx(), getmaxy());
	setcolor(7);
	estat("[Rectangle]. Selecciona amb cursors el segon punt, i ENTER per confirmar");
	cursors(&x2, &y2);
	putpixel(x2, y2, 12);
	setcolor(0);
	rectangle (x1, y1, x2, y2);
}

void estat (char *text)
{
	setcolor(1);
	setfillstyle(SOLID_FILL, 1);
	bar(0, getmaxy()-8, getmaxx(), getmaxy());
	setcolor(7);
	outtextxy(0, getmaxy()-8, text);
}

void cursors (int *x, int *y)
{
	char tecla;

	*x=getmaxx()/2;
	*y=getmaxy()/2;
	setcolor(0);
	outtextxy(*x, *y, "+");
	do
	{
		tecla=getch();
		setcolor(7);
		outtextxy(*x, *y, "+");
		if (tecla=='4')
			(*x)--;
		else if (tecla=='6')
			(*x)++;
		else if (tecla=='8')
			(*y)--;
		else if (tecla=='2')
			(*y)++;
		if ((*x)<0)
			(*x)=0;
		else if ((*x)>getmaxx())
			(*x)=getmaxx();
		if ((*y)<0)
			(*y)=0;
		else if ((*y)>getmaxy())
			(*y)=getmaxy();
		setcolor(0);
		outtextxy(*x, *y, "+");
	}
	while (tecla!=13);
	setcolor(7);
	outtextxy(*x, *y, "+");
}

void numero (int *n, int min, int max)
{
	char tecla;
	char tmp[80];

	*n=min;
	setcolor(7);
	do
	{
		sprintf(tmp, "(%d-%d): %d", min, max, *n);
		estat(tmp);
		tecla=getch();
		if (tecla=='2')
			(*n)--;
		else if (tecla=='8')
			(*n)++;
		if ((*n)<min)
			(*n)=min;
		else if ((*n)>max)
			(*n)=max;
	}
	while (tecla!=13);
}

