/* ͻ */
/*                                                                         */
/*                    */
/*                                       */
/*                                      */
/*                                     */
/*                                                                         */
/*                                                           */
/*                                                               */
/*                                                               */
/*                                                           */
/*                                                                         */
/*                                             */
/*                                                        */
/*                                                         */
/*                                             */
/*                                                                         */
/*                                                                         */
/*                               */
/*                                                                     */
/*                              Versi 1.00                            */
/*                                                                     */
/*                                   Per                               */
/*                                                                     */
/*                       Bernardino Casas Fernndez                    */
/*                                                                     */
/*                                   i                                 */
/*                                                                     */
/*                       Javier Gutirrez Chamorro                     */
/*                                                                     */
/*                               */
/*                                                                         */
/*                                                                         */
/*                                                                         */
/*  NOTES: Com que s'havien d'utilitzar les funcions grfiques del         */
/*         TURBO C/C++, la rotaci de l'el.lipse no est permesa.          */
/*         Si es volgus que funcions correctament s'hauria               */
/*         d'implementar les el.lipses mitjanant Bresenham.               */
/*                                                                         */
/* ͼ */

/* ------------------------------ Inclusions ------------------------------ */
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <math.h>
#include <dos.h>
#include <bios.h>
#include <alloc.h>
#include <conio.h>
#include <graphics.h>
#include <io.h>

/* ------------------------------- Constants ------------------------------ */
#define PI 3.141592654
#define MAX_VECTOR 500
#define PAUSA 250
#define dret 0
#define esq 1

#define ID_BUIT						0
#define ID_ARC						1
#define ID_CIRCUMFERENCIA	2
#define ID_ELIPSE					3
#define ID_LINIA					4
#define ID_POLIGONIREG		5
#define ID_POLIGONREG			6
#define ID_RECTANGLE			7
#define ID_POLIGONPART		10


/* -------------------------- Funcions de suport -------------------------- */
unsigned int pascal esrata (void);
void pascal mostrarrata (void);
void pascal ocultarrata (void);
void pascal llegirrata (int *, int *, int *);
void pascal guardarrata (int, int, int);
void pascal margerata (int, int, int, int);
char * pascal puntua (long int);

/* ----------------------- Funcions de baix nivell  ----------------------- */
void pascal entrar (void);
void pascal sortir (unsigned int);
void pascal fons (void);
void pascal caixa (unsigned int, unsigned int, unsigned int, unsigned int, char *);
void pascal estat (char *);
unsigned int pascal vmenu (unsigned int, unsigned int, char [][41], unsigned int, unsigned int);
unsigned int pascal hmenu (unsigned int, unsigned int, char [][21], unsigned int, unsigned int);
void pascal boto (unsigned int, unsigned int, char *);
void pascal cadena (unsigned int, unsigned int, char *, unsigned int);
void pascal numero (unsigned int, unsigned int, int *, int, int, int);
int pascal numero2 (unsigned int, unsigned int);
void escriure (unsigned int, unsigned int, unsigned int, unsigned int, char *, ...);
void pascal cursor (int *, int *);
void pascal avis (char *);

/* ------------------------ Funcions d'alt nivell  ------------------------ */
void pascal sobre (void);
void pascal info (void);
void pascal principal (void);
void pascal inserir (void);
void pascal esborrar (void);
void pascal carregarvec (void);
void pascal grabarvec (void);
void pascal carregarraw (void);
void pascal grabarraw (void);
void pascal dibuixar_figura (int, int);
void pascal refrescar (void);
void pascal inserir_fig_vector (int, int, int, int, int, int, int, int, char sim[22], int, unsigned char);
void pascal esborrartot (unsigned int);
void pascal esborrar_figura (void);
void pascal esborrar_fig_permanent (void);
void pascal desfer_esborrat (void);
void pascal ferarc (void);
void pascal fercircumferencia (void);
void pascal ferelipse (void);
void pascal ferlinia (void);
void pascal ferpoligonireg (void);
void pascal ferpoligonreg (void);
void pascal ferrectangle (void);
int pascal triarfigura (unsigned int);
void pascal transformar (void);
void pascal copiar (void);
void pascal traslladar (void);
void pascal girar (void);
void pascal escalar (void);
void pascal comparar_punts(int, int, float, float, int);
void pascal maxim_punt (int, float, float, float, float);
void pascal empalmament (void);
void pascal empalmament_rectilini (int *, int *);
void pascal empalmament_arc (void);
void pascal empalmament_xamfra (void);
struct svector pascal calcul_paralela (int, int, int);
int pascal distancia (int, int, int, int);

/* ---------------------------- Vector de figures ------------------------- */
unsigned int index=0;
struct svector
{
	int id;
	int x1;
	int y1;
	int x2;
	int y2;
	int a1;
	int a2;
	char sim[22];
	int next;
	unsigned char afes;
} vector[MAX_VECTOR];


/* --------------------------- Funci principal --------------------------- */
void main (void)
{
	entrar();
	fons();
	sobre();
	info();
	esborrartot(1);
	principal();
	sortir(0);
}

/* ------------------------- Mira si hi ha ratoli ------------------------- */
unsigned int pascal esrata (void)
{
	union REGS r;

	r.x.ax=0;
	int86(0x33, &r, &r);
	if (r.x.ax==0)
		return(0);
	else
		return(r.x.bx);
}

/* -------------------------- Ensenya el ratol --------------------------- */
void pascal mostrarrata (void)
{
	union REGS r;

	r.x.ax=1;
	int86(0x33, &r, &r);
}

/* --------------------------- Oculta el ratol --------------------------- */
void pascal ocultarrata (void)
{
	union REGS r;

	r.x.ax=2;
	int86(0x33, &r, &r);
}

/* ------------------- Llegeix les coordenades del ratol ----------------- */
void pascal llegirrata (int *x, int *y, int *b)
{
	union REGS r;

	r.x.ax=3;
	int86(0x33, &r, &r);
	*b=r.x.bx;
	*x=r.x.cx;
	*y=r.x.dx;
}

/* ------------------- Guarda les coordenades del ratol ------------------ */
void pascal guardarrata (int x, int y, int b)
{
	union REGS r;

	r.x.ax=4;
	r.x.bx=b;
	r.x.cx=x;
	r.x.dx=y;
	int86(0x33, &r, &r);
}

/* ------------------- Guarda les coordenades del ratol ------------------ */
void pascal margerata (int x1, int y1, int x2, int y2)
{
	union REGS r;

	r.x.ax=7;
	r.x.cx=x1;
	r.x.dx=x2;
	int86(0x33, &r, &r);
	r.x.ax=8;
	r.x.cx=y1;
	r.x.dx=y2;
	int86(0x33, &r, &r);

}

/* ------------------------- Puntua un nmero  ---------------------------- */
char * pascal puntua (long int n)
{
	register unsigned int i, j=0, k=0;
	static char tmp[15], res[20];

	memset(tmp, 0, 15);
	memset(res, 0, 20);
	ltoa(n, tmp, 10);
	if (n<1000)
		return(tmp);
	strrev(tmp);
	for (i=0; i!=strlen(tmp); i++)
	{
		if (j==3)
		{
			j=0;
			res[k]='.';
			k++;
		}
		res[k]=tmp[i];
		j++;
		k++;
	}
	strrev(res);
	return(res);
}

/* ------------ Inicialitza el mode grfic 640x480 16/256 colors  --------- */
void pascal entrar (void)
{
	int driver, mode;

	textattr(15);
	cprintf("Prctica de Geometria Computacional I v1.00 per DOS ");
	textattr(7);
	cputs("[VGA 640x480 16 colors]\r\n");
	delay(PAUSA);
	/* 640x480 16 colors */
	driver=VGA;
	mode=VGAHI;
	initgraph (&driver, &mode, "c:\\d\\llprog\\tc");
	if (graphresult()!=grOk)
		sortir(1);
	if (!esrata())
		sortir(2);
	guardarrata(320, 240, 0);
	margerata(1, 1, 639, 471);
}

/* -------------------------- Surt del programa --------------------------- */
void pascal sortir (unsigned int e)
{
	register unsigned int i;
	char *oldb;
	char sino[][21]={	"Si, vull sortir",
							"No, vull seguir"};


	if (e==0)
	{
		oldb=malloc(imagesize(180, 180, 459, 259));
		if (oldb==0)
			sortir(3);
		getimage(180, 180, 459, 259, oldb);
		caixa(180, 180, 459, 259, "Sortir al OS");
		escriure(200, 200, 0, 15, "Segur que vols sortir del");
		escriure(200, 210, 0, 15, "programa?");
		estat("[Sortir]. Tria el bot desitjat.");
		i=hmenu(190, 239, sino, 2, 17*8);
		putimage(180, 180, oldb, COPY_PUT);
		free(oldb);
		if (i==1)
			return;
		else
		{
			closegraph();
			textattr(15);
			cputs("Prctica de Geometria Computacional I v1.00 per DOS\r\n");
			textattr(2);
			cputs("Tot ha concluit correctament.\r\n");
		}
	}
	else if (e==1)
	{
		closegraph();
		textattr(12);
		cprintf("Error(01): Impossible inicialitzar grfics.\r\n");
	}
	else if (e==2)
	{
		closegraph();
		textattr(12);
		cprintf("Error(02): Impossible inicialitzar ratol.\r\n");
	}
	else if (e==2)
	{
		closegraph();
		textattr(12);
		cprintf("Error(03): Impossible reservar memria.\r\n");
	}
	textattr(7);
	cputs(" \r");
	exit(e);
}

/* ------------------- Dibuixa el fons de la pantalla --------------------- */
void pascal fons (void)
{
	cleardevice();
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 0, 639, 471);
	setcolor(8);
	rectangle(0, 470, 639, 479);
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 471, 638, 478);
}

/* --------------------- Actualiza la linia d'estat ----------------------- */
void pascal estat (char *text)
{
	setcolor(8);
	rectangle(0, 470, 639, 479);
	setcolor(7);
	setfillstyle(SOLID_FILL, 7);
	bar(0, 471, 638, 478);
	setcolor(0);
	outtextxy(4, 471, text);
}

/* ---------------------------- Dibuixa un boto --------------------------- */
void pascal boto (unsigned int x, unsigned int y, char *text)
{
	setcolor(0);
	rectangle(x, y, x+(strlen(text)<<3)+4, y+12);
	setcolor(8);
	rectangle(x+1, y+1, x+(strlen(text)<<3)+3, y+11);
	setfillstyle(SOLID_FILL, 7);
	bar(x+2, y+2, x+(strlen(text)<<3)+2, y+10);
	setcolor(0);
	outtextxy(x+3, y+3, text);
}

/* -------------------------- Dibuixa una caixa --------------------------- */
void pascal caixa (unsigned int x1, unsigned int y1, unsigned int x2, unsigned int y2, char *text)
{
	setcolor(15);
	setfillstyle(SOLID_FILL, 1);
	bar(x1+4, y1+4, x2-4, y1+15);
	escriure(x1+6, y1+6, 15, 1, text);
	setcolor(0);
	rectangle(x1, y1, x2, y2);
	rectangle(x1+1, y1+1, x2-1, y2-1);
	setcolor(8);
	rectangle(x1+2, y1+2, x2-2, y2-2);
	rectangle(x1+3, y1+3, x2-3, y2-3);
	setcolor(15);
	setfillstyle(SOLID_FILL, 15);
	bar(x1+4, y1+16, x2-4, y2-4);
}

/* -------------------------- Fa un menu vertical ------------------------- */
unsigned int pascal vmenu (unsigned int x1, unsigned int y1, char menu[][41], unsigned int noptions, unsigned int separation)
{
	register int y, x;
	int tx, ty, l;

	l=strlen(menu[0])-1;
	for (y=0; y!=noptions; y++)
		boto(x1, y1+y*separation, menu[y]);
	y=-1;
	do
	{
		cursor(&tx, &ty);
		if ((tx>=x1) && (tx<=(x1+(l<<3))))
		{
			x=(ty-y1)/separation;
			if ((x>=0) && (x<noptions))
				y=x;
		}
	}
	while (y==-1);
	return(y);
}

/* ------------------------- Fa un menu horitzontal ----------------------- */
unsigned int pascal hmenu (unsigned int x1, unsigned int y1, char menu[][21], unsigned int noptions, unsigned int separation)
{
	register int y, x;
	int tx, ty;

	for (x=0; x!=noptions; x++)
		boto(x1+x*separation, y1, menu[x]);
	x=-1;
	do
	{
		cursor(&tx, &ty);
		if ((ty>=y1) && (ty<=y1+8))
		{
			y=(tx-x1)/separation;
			if ((y>=0) && (y<noptions))
				x=y;
		}
	}
	while (x==-1);
	return(x);
}

/* ------------- Fa una menu vertical per introduir una cadena ----------- */
void pascal cadena (unsigned int x1, unsigned int y1, char *text, unsigned int max)
{
	char tmp[80];

	text[0]=max;
	sprintf(tmp, "[Introduir]. Introdueix la dada requerida (max %d carcters).", max);
	estat(tmp);
	directvideo=0;
	memset(&text[2], 0, max+1);
	memset(&text[2], 32, max);
	gotoxy(x1>>3, y1>>4);
	cputs(&text[2]);
	gotoxy(x1>>3, y1>>4);
	cgets(text);
	directvideo=1;
	strcpy(text, &text[2]);
}

/* ------------ Fa un menu vertical per introduir nombres --------------- */
void pascal numero (unsigned int x, unsigned int y, int *n, int inc, int min, int max)
{
	register unsigned int tecla;
	char tmp[80];

	delay(PAUSA*4);
	sprintf(tmp, "[Introduir]. Utilitza els cursors per variar el nmero (%d-%d).", min, max);
	estat(tmp);
	*n=min;
	do
	{
		escriure(x, y, 7, 0, "%8d", *n);
		tecla=bioskey(0);
		if (tecla==0x4800)
			(*n)+=inc;
		else if (tecla==0x5000)
			(*n)-=inc;
		else if (tecla==0x4900)
			(*n)+=10*inc;
		else if (tecla==0x5100)
			(*n)-=10*inc;
		else if (tecla==0x4700)
			(*n)=min;
		else if (tecla==0x4F00)
			(*n)=max;
		if ((*n)<min)
			(*n)=min;
		else if ((*n)>max)
			(*n)=max;
	}
	while (tecla!=0x1C0D);
}

/* ----------- Fa un menu vertical per entrar nombres per teclat ---------- */
int pascal numero2 (unsigned int x, unsigned int y)
{
	int m=0, n;

	escriure(x, y, 7, 0, "%8d", m);
	n=getch();
	while (n!=13)
	{
		if ((n>47) && (n<58))
		{
			m=(n-'0')+m*10;
			escriure(x, y, 7, 0, "%8d", m);
		}
		else
		{
			if (n==8)
			{
				m=m / 10;
				escriure(x, y, 7, 0, "%8d", m);
			}
		}
		n=getch();
	}
	return m;
}

/* ------------------- Actualitza la posici del cursor ------------------- */
void pascal cursor (int *x, int *y)
{
	register unsigned int tecla;
	int b;

	mostrarrata();
	delay(PAUSA);
	do
	{
		do
		{
			llegirrata(x, y, &b);
			if (b&1)
				tecla=0x1C0D;
			else if (b&2)
				tecla=0x011B;
			else
				tecla=bioskey(1);
		}
		while (!tecla);
		if (b&1)
			tecla=0x1C0D;
		else if (b&2)
				tecla=0x011B;
		else
			tecla=bioskey(0);
		if (tecla==0x4800)
			(*y)--;
		else if (tecla==0x5000)
			(*y)++;
		else if (tecla==0x4B00)
			(*x)--;
		else if (tecla==0x4D00)
			(*x)++;
		if ((*x)<0)
			*x=0;
		else if ((*x)>639)
			*x=639;
		if ((*y)<0)
			*y=0;
		else if ((*y)>479)
			*y=479;
		guardarrata(*x, *y, 0);
		escriure(520, 471, 0, 7, "(%03d, %03d)", *x, *y);
	}
	while ((tecla!=0x1C0D) && (tecla!=0x011B));
	if (tecla==0x011B)
	{
		*x=-1;
		*y=-1;
	}
	ocultarrata();
}

/* ---------------------- Escriu un text a pantalla ----------------------- */
void escriure (unsigned int x, unsigned int y, unsigned int c1, unsigned int c2, char *buf, ...)
{
	 va_list argptr;
	 char aux[256];

	 va_start(argptr, buf);
	 vsprintf(aux, buf, argptr);
	 va_end(argptr);

	 setcolor(c1);
	 setfillstyle(SOLID_FILL, c2);
	 bar(x, y, x+(strlen(aux)<<3), y+8);
	 outtextxy(x, y, aux);
}

/* ------------------- Mostra la ventana d'informaci --------------------- */
void pascal avis (char *text)
{
	int x, y;
	int x1, x2, tam;
	char *oldb;

	tam=(strlen(text)+4)<<3;
	x1=320-(tam>>1);
	x2=320+(tam>>1);

	oldb=malloc(imagesize(x1, 210, x2, 270));
	if (oldb==0)
		sortir(3);
	getimage(x1, 210, x2, 270, oldb);
	caixa(x1, 210, x2, 270, "Avis");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	outtextxy(320, 230, "ATENCIO!");
	outtextxy(320, 250, text);
	settextjustify(LEFT_TEXT, TOP_TEXT);
	cursor(&x, &y);
	putimage(x1, 210, oldb, COPY_PUT);
	free(oldb);
}

/* --------------------- Mostra la ventana del sobre ---------------------- */
void pascal sobre (void)
{
	int k;
	char *oldb;

	oldb=malloc(imagesize(200, 100, 479, 300));
	if (oldb==0)
		sortir(3);
	getimage(200, 100, 479, 300, oldb);
	caixa(200, 100, 479, 300, "Sobre el programa");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	outtextxy(339, 135, "Prctica de GEOC I v1.00");
	outtextxy(339, 155, "-");
	outtextxy(339, 175, "Aquest programari s");
	outtextxy(339, 185, "realitzat per:");
	outtextxy(339, 205, "Bernardino Casas Fernndez");
	outtextxy(339, 215, "Javier Gutirrez Chamorro");
	outtextxy(339, 235, "");
	outtextxy(339, 255, "(c) Copyright 1997-1998.");
	outtextxy(339, 265, "Tots els drets reservats");
	settextjustify(LEFT_TEXT, TOP_TEXT);
	estat("[Sobre]. Pitja qualsevol tecla o bot.");
	cursor(&k, &k);
	putimage(200, 100, oldb, COPY_PUT);
	free(oldb);
}

/* ------------------- Mostra la ventana d'informaci --------------------- */
void pascal info (void)
{
	int k;
	char *oldb;
	char tmp[80];

	oldb=malloc(imagesize(50, 180, 589, 320 ));
	if (oldb==0)
		sortir(3);
	getimage(50, 180, 589, 320, oldb);
	caixa(50, 180, 589, 320, "Informaci");
	settextjustify(CENTER_TEXT, TOP_TEXT);
	setcolor(0);
	sprintf(tmp, "Memoria base total: %u Koctets", biosmemory());
	outtextxy(320, 200, tmp);
	sprintf(tmp, "Memoria base lliure: %u Koctets", coreleft()>>10);
	outtextxy(320, 210, tmp);
	sprintf(tmp, "Mode de video: VGA 640x480 16 colors");
	outtextxy(320, 230, tmp);
	if (_8087==0)
		sprintf(tmp, "Coprocessador matemtic: No instal.lat");
	else
		sprintf(tmp, "Coprocessador matemtic: 80%u87 instal.lat", _8087);
	outtextxy(320, 250, tmp);
	sprintf(tmp, "Ratol: %u botons instal.lat", esrata());
	outtextxy(320, 270, tmp);
	sprintf(tmp, "DOS versi: %u.%02u", _osmajor, _osminor);
	outtextxy(320, 290, tmp);
	settextjustify(LEFT_TEXT, TOP_TEXT);
	cursor(&k, &k);
	putimage(50, 180, oldb, COPY_PUT);
	free(oldb);
}


/* ---------------------- Mostra el men principal ------------------------ */
void pascal principal (void)
{
	register int i;
	int x, y;
	char *oldb;
	char tmp[70];
	char menu[][41]={
										"        Inserir...       ",
										"        Esborrar...      ",
										"      Transformar...     ",
										"      Empalmament...     ",
										"Carregar vectorial (.VEC)",
										"Guardar vectorial (.VEC) ",
										"Carregar pantalla (.RAW) ",
										" Guardar pantalla (.RAW) ",
										"    Refrescar pantalla   ",
										"        Cancel.lar       ",
										"          Sortir         "
									};
	while(1)
	{
		do
		{
			estat("[Principal]. Escape o bot dret per veure el menu");
			do
			{
				cursor(&x, &y);
				if (x!=-1)
				{
					sprintf(tmp, "%u de %u usat (%u%% lliure)", index, MAX_VECTOR, 100-(index*100/MAX_VECTOR));
					avis(tmp);
				}
			}
			while (x!=-1);
			estat("[Principal]. Marca la comanda desitjada");
			oldb=malloc(imagesize(190, 120, 449, 369));
			if (oldb==0)
				sortir(3);
			getimage(190, 120, 449, 369, oldb);
			caixa(190, 120, 449, 369, "Menu Principal");
			i=vmenu(215, 150, menu, 11, 18);
			putimage(190, 120, oldb, COPY_PUT);
			free(oldb);
			if (i==0)
				inserir();
			else if (i==1)
				esborrar();
			else if (i==2)
				transformar();
			else if (i==3)
				empalmament();
			else if (i==4)
				carregarvec();
			else if (i==5)
				grabarvec();
			else if (i==6)
				carregarraw();
			else if (i==7)
				grabarraw();
			else if (i==8)
				refrescar();
		}
		while (i!=10);
		sortir(0);
	}
}

/* ----------------------- Mostra el men inserir ------------------------- */
void pascal inserir (void)
{
	register int i;
	char *oldb;
	char menu[][41]={
										"          Linia          ",
										"           Arc           ",
										"      Circumferencia     ",
										"      Polgon Regular    ",
										"     Polgon Irregular   ",
										"         El.lipse        ",
										"         Rectangle       ",
										"        Cancel.lar       ",

									};

	estat("[Inserir]. Marca la comanda desitjada");
	oldb=malloc(imagesize(190, 130, 449, 349));
	if (oldb==0)
		sortir(3);
	getimage(190, 130, 449, 349, oldb);
	caixa(190, 130, 449, 349, "Menu Inserir");
	i=vmenu(215, 165, menu, 8, 18);
	putimage(190, 130, oldb, COPY_PUT);
	free(oldb);
	if (i==0)
		ferlinia();
	else if (i==1)
		ferarc();
	else if (i==2)
		fercircumferencia();
	else if (i==3)
		ferpoligonreg();
	else if (i==4)
		ferpoligonireg();
	else if (i==5)
		ferelipse();
	else if (i==6)
		ferrectangle();
}


/* ---------------------- Carrrega una imatge .RAW ------------------------ */
void pascal carregarraw (void)
{
	register unsigned int x, y;
	FILE *f;
	char *oldb;
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Carregar RAW");
	escriure(200, 200, 0, 15, "Nom del fitxer a carregar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".RAW");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	f=fopen(nom, "rb");
	if (f==0)
	{
		avis("Impossible obrir fitxer");
		return;
	}
	for (y=0; y<13; y++)
	{
		fread(tmp, 1, 640, f);
	}
	for (y=13; y<=471; y++)
	{
		if (y%48==0)
		{
			sprintf(tmp, "[Carregant]. %s (%3u%%)...", nom, y*100/480);
			estat(tmp);
		}
		fread(tmp, 1, 640, f);
		for (x=0; x<640; x++)
			putpixel(x, y, tmp[x]);
	}
	for (y=472; y<480; y++)
	{
		fread(tmp, 1, 640, f);
	}
	fclose(f);
}

/* ------------------------ Guarda una imatge .RAW ----------------------- */
void pascal grabarraw (void)
{
	register unsigned int x, y;
	FILE *f;
	char *oldb;
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Grabar RAW");
	escriure(200, 200, 0, 15, "Nom del fitxer a grabar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".RAW");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	f=fopen(nom, "wb");
	if (f==0)
	{
		avis("Impossible crear fitxer");
		return;
	}
	memset(tmp, 7, 640);
	for(y=0; y<13; y++)
	{
		fwrite(tmp, 1, 640, f);
	}
	for (y=13; y<=471; y++)
	{
		if (y%48==0)
		{
			sprintf(tmp, "[Guardant]. %s (%3u%%)...", nom, y*100/480);
			estat(tmp);
		}
		for (x=0; x<640; x++)
			tmp[x]=getpixel(x, y);
		fwrite(tmp, 1, 640, f);
	}
	memset(tmp, 7, 640);
	for(y=472; y<480; y++)
	{
		fwrite(tmp, 1, 640, f);
	}
	fclose(f);
}

/* ---------------------- Carrrega una imatge .VEC ------------------------ */
void pascal carregarvec (void)
{
	FILE *f;
	char *oldb;
	char vechea[32];
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Carregar VEC");
	escriure(200, 200, 0, 15, "Nom del fitxer a carregar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".VEC");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	f=fopen(nom, "rb");
	if (f==0)
	{
		avis("Impossible obrir fitxer");
		return;
	}
	esborrartot(1);
	sprintf(tmp, "[Carregant]. %s (%3u%%)...", nom, 0);
	estat(tmp);
	fread(vechea, 1, 32, f);
	if (strcmp(vechea, "Fitxer VECtor de GEOC1")!=0)
	{
		avis("No s un fitxer .VEC");
		fclose(f);
		return;
	}
	fread(&vector, 1, filelength(fileno(f)), f);
	sprintf(tmp, "[Carregant]. %s (%3u%%)...", nom, 100);
	estat(tmp);
	index=filelength(fileno(f))/sizeof(struct svector);
	fclose(f);
	refrescar();
}

/* ------------------------ Guarda una imatge .VEC ------------------------ */
void pascal grabarvec (void)
{
	FILE *f;
	char *oldb;
	char nom[81];
	char tmp[640];

	oldb=malloc(imagesize(180, 180, 459, 229));
	if (oldb==0)
		sortir(3);
	getimage(180, 180, 459, 229, oldb);
	caixa(180, 180, 459, 229, "Grabar VEC");
	escriure(200, 200, 0, 15, "Nom del fitxer a grabar?");
	cadena(200, 230, nom, 30);
	strupr(nom);
	if (strchr(nom, '.')==0)
		strcat(nom, ".VEC");
	directvideo=0;
	gotoxy(200/8, 230/16);
	cputs(nom);
	directvideo=1;
	putimage(180, 180, oldb, COPY_PUT);
	free(oldb);
	f=fopen(nom, "wb");
	if (f==0)
	{
		avis("Impossible crear fitxer");
		return;
	}
	sprintf(tmp, "[Guardant]. %s (%3u%%)...", nom, 0);
	estat(tmp);
	fwrite("Fitxer VECtor de GEOC1", 1, 32, f);
	fwrite(&vector, sizeof(struct svector), index, f);
	sprintf(tmp, "[Guardant]. %s (%3u%%)...", nom, 100);
	estat(tmp);
	fclose(f);
}


/* ------------------ Dibuixa la figura de la taula --------------------- */
void pascal dibuixar_figura (int i, int color)
{
	int j, k, x1, y1, x2, y2;
	float angle, dx, dy;
	char tmp[80];
	int poligon[42];

	if (vector[i].afes==1)
	{
		sprintf(tmp, "Dibuixant %s", vector[i].sim);
		estat(tmp);
		setcolor(color);
		setviewport(0, 0, 639, 471, 1);
		switch (vector[i].id)
		{
			case ID_ARC:
				arc(vector[i].x1, vector[i].y1, vector[i].a1, vector[i].a2, vector[i].x2);
				break;

			case ID_CIRCUMFERENCIA:
				circle(vector[i].x1, vector[i].y1, vector[i].x2);
				break;

			case ID_ELIPSE:
				ellipse(vector[i].x1, vector[i].y1, 0, 360, vector[i].x2, vector[i].y2);
				break;

			case ID_LINIA:
				line (vector[i].x1, vector[i].y1, vector[i].x2, vector[i].y2);
				break;

			case ID_POLIGONREG:
				angle=(360/vector[i].a1)*(PI/180);
				dx=vector[i].x2-vector[i].x1;
				dy=vector[i].y2-vector[i].y1;
				for (j=0, k=0; j<(vector[i].a1*2); j+=2, k++)
				{
					poligon[j]=dx*cos(angle*k)+dy*(-sin(angle*k));
					poligon[j+1]=dx*sin(angle*k)+dy*cos(angle*k);
				}
				poligon[j]=poligon[0];
				poligon[j+1]=poligon[1];
				for (j=0; j<=((vector[i].a1+1)*2); j+=2)
				{
					poligon[j]+=vector[i].x1;
					poligon[j+1]+=vector[i].y1;
				}
				drawpoly(vector[i].a1+1,poligon);
				break;

			case ID_RECTANGLE:
			case ID_POLIGONIREG:
				j=i;
				x1=vector[i].x1;
				y1=vector[i].y1;
				i=vector[i].next;
				while (i!=-1)
				{
					x2=vector[i].x1;
					y2=vector[i].y1;
					line (x1, y1, x2, y2);
					x1=x2;
					y1=y2;
					i=vector[i].next;
				}
				line (x1,y1,vector[j].x1,vector[j].y1);
				break;

/*			case ID_RECTANGLE:
				rectangle(vector[i].x1, vector[i].y1-13, vector[i].x2, vector[i].y2-13);
				break; */
		}
		setviewport(0, 0, 639, 439, 0);
	}
}

/* -------------------------- Refresca la pantalla ------------------------ */
void pascal refrescar (void)
{
	register unsigned int i;

	fons();
	for (i=0; i<=index; i++)
		dibuixar_figura(i,0);
}

/* -------------------- Inserir figura en el vector ----------------------- */
void pascal inserir_fig_vector (int i, int id, int x1, int y1, int x2, int y2,	int a1, int a2, char sim[22], int next, unsigned char afes)
{
	vector[i].id=id;
	vector[i].x1=x1;
	vector[i].y1=y1;
	vector[i].x2=x2;
	vector[i].y2=y2;
	vector[i].a1=a1;
	vector[i].a2=a2;
	sprintf(vector[i].sim, sim, i);
	vector[i].next=next;
	vector[i].afes=afes;
}

/* --------------------------------- Fa un Arc ---------------------------- */
void pascal ferarc (void)
{
	int x1, y1, x2, y2, s1, s2, r;

	estat("[Arc]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursor(&x1, &y1);
	if (x1!=-1)
	{
		putpixel(x1, y1, 12);
		estat("[Arc]. Selecciona amb cursors el radi, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			putpixel(x2, y2, 12);
			estat("[Arc]. Entra el primer angle...");
			numero(550, 470, &s1, 1, 0, 360);
			estat("[Arc]. Entra el segon angle...");
			numero(550, 470, &s2, 1, 0, 360);
			r=max(abs(y2-y1), abs(x2-x1));
			inserir_fig_vector(index,ID_ARC,x1,y1,r,-1,s1,s2,"ARC %u",-1,1);
			index++;
		}
	}
	refrescar();
}

/* -------------------------- Fa una circumferncia ----------------------- */
void pascal fercircumferencia (void)
{
	int x1, y1, x2, y2, r;

	estat("[Circumferencia]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursor(&x1, &y1);
	if (x1!=-1)
	{
		putpixel(x1, y1, 12);
		estat("[Circumferencia]. Selecciona amb cursors el radi, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			putpixel(x2, y2, 12);
			r=distancia(x1,y1,x2,y2);
//			sqrt(pow((y2-y1),2)+pow((x2-x1),2));
			inserir_fig_vector(index,ID_CIRCUMFERENCIA,x1,y1,r,-1,-1,-1,"CIRCUMFERENCIA %u",-1,1);
			index++;
		}
	}
	refrescar();
}

/* ----------------------------- Fa una ellipse -------------------------- */
void pascal ferelipse (void)
{
	int x1, y1, x2, y2, x3, y3;

	estat("[El.lipse]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursor(&x1, &y1);
	if (x1!=-1)
	{
		putpixel(x1, y1, 12);
		estat("[El.lipse]. Selecciona amb cursors el radi x, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			putpixel(x2, y2, 12);
			estat("[El.lipse]. Selecciona amb cursors el radi y, i ENTER per confirmar");
			cursor(&x3, &y3);
			if (x3!=-1)
			{
				putpixel(x3, y3, 12);
				inserir_fig_vector(index,ID_ELIPSE,x1,y1,abs(x2-x1),abs(y3-y1),-1,-1,"EL.LIPSE %u",-1,1);
				index++;
			}
		}
	}
	refrescar();
}

/* ------------------------------ Fa una Lnia ---------------------------- */
void pascal ferlinia (void)
{
	int x1, y1, x2, y2;

	estat("[Linea]. Selecciona amb cursors el primer punt, i ENTER per confirmar");
	cursor(&x1, &y1);
	if (x1!=-1)
	{
		putpixel(x1, y1, 12);
		estat("[Linea]. Selecciona amb cursors el segon punt, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			putpixel(x2, y2, 12);
			inserir_fig_vector(index,ID_LINIA,x1,y1,x2,y2,-1,-1,"LINIA %u",-1,1);
			index++;
		}
	}
	refrescar();
}

/* ------------------------- Fa un Polgon Regular ------------------------ */
void pascal ferpoligonreg (void)
{
	int x1, y1, x2, y2, n;

	estat("[PoligonReg]. Selecciona amb cursors el centre, i ENTER per confirmar");
	cursor(&x1, &y1);
	if (x1!=-1)
	{
		putpixel(x1, y1, 12);
		estat("[PoligonReg]. Selecciona amb cursors un vrtex, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			putpixel(x2, y2, 12);
			estat("[PoligonReg]. Entra el nmero de costats...");
			numero(550, 470, &n, 1, 3, 20);
			inserir_fig_vector(index,ID_POLIGONREG,x1,y1,x2,y2,n,-1,"POLIGON REGULAR %u",-1,1);
			index++;
		}
	}
	refrescar();
}

/* ------------------------- Fa un Polgon Irregular ---------------------- */
void pascal ferpoligonireg (void)
{
	int x1, y1, inici=-1;

	estat("[PoligonIreg]. Entra el primer punt, o prem el bot dret per sortir");
	cursor(&x1, &y1);

	while (x1!=-1)
	{
		if (inici==-1)
		{
			vector[index].id=ID_POLIGONIREG;
			sprintf(vector[index].sim, "POLIGON IRREGULAR %u", index);
			inici=index;
		}
		else
		{
			vector[index].id=ID_POLIGONPART;
			sprintf(vector[index].sim, "PART DE POLIGON %u", index);
			vector[index-1].next=index;
		}
		vector[index].x1=x1;
		vector[index].y1=y1;
		vector[index].x2=-1;
		vector[index].y2=-1;
		vector[index].a1=-1;
		vector[index].a2=-1;
		vector[index].afes=1;
		index++;
		putpixel(x1, y1, 12);
		estat("[PolIreg]. Entra un altre punt, o prem el bot dret per acabar");
		cursor(&x1, &y1);
	}
	vector[index-1].next=-1;
	refrescar();
}

/* ---------------------------- Fa un Rectangle --------------------------- */
void pascal ferrectangle (void)
{
	int x1, y1, x2, y2;

	estat("[Rectangle]. Selecciona amb cursors el primer punt, pitja ENTER per confirmar");
	cursor(&x1, &y1);
	if (x1!=-1)
	{
		putpixel(x1, y1, 12);
		estat("[Rectangle]. Selecciona amb cursors el segon punt, i ENTER per confirmar");
		cursor(&x2, &y2);
		if (x2!=-1)
		{
			putpixel(x2, y2, 12);
			inserir_fig_vector(index,ID_RECTANGLE,x1,y1,-1,-1,-1,-1,"RECTANGLE %u",index+1,1);
			index++;
			inserir_fig_vector(index,ID_POLIGONPART,x1,y2,-1,-1,-1,-1,"PART DE RECTANGLE %u",index+1,1);
			index++;
			inserir_fig_vector(index,ID_POLIGONPART,x2,y2,-1,-1,-1,-1,"PART DE RECTANGLE %u",index+1,1);
			index++;
			inserir_fig_vector(index,ID_POLIGONPART,x2,y1,-1,-1,-1,-1,"PART DE RECTANGLE %u",-1,1);
			index++;
		}
	}
	refrescar();
}

/* ---------------------- Mostra el men d'esborrar ----------------------- */
void pascal esborrar (void)
{
	register int i;
	char *oldb;
	char menu[][41]={
										"       Esborrar Tot      ",
										"     Esborrar Figura     ",
										" Esborrar Fig. Permanent ",
										"     Desfer Esborrat     ",
										"        Cancel.lar       ",

									};

	estat("[Esborrar]. Marca la comanda desitjada");
	oldb=malloc(imagesize(190, 150, 449, 329));
	if (oldb==0)
		sortir(3);
	getimage(190, 150, 449, 329, oldb);
	caixa(190, 150, 449, 329, "Menu Esborrar");
	i=vmenu(215, 190, menu, 5, 18);
	putimage(190, 150, oldb, COPY_PUT);
	free(oldb);
	if (i==0)
		esborrartot(0);
	else if (i==1)
		esborrar_figura();
	else if (i==2)
		esborrar_fig_permanent();
	else if (i==3)
		desfer_esborrat();
}

/* ------------------------- Esborra la pantalla ------------------------ */
void pascal esborrartot (unsigned int e)
{
	register unsigned int i;
	char *oldb;
	char sino[][21]={	"Esborrar tot",
							" Cancel.lar "};

	if (e==0)
	{
		oldb=malloc(imagesize(180, 180, 459, 259));
		if (oldb==0)
			sortir(3);
		getimage(180, 180, 459, 259, oldb);
		caixa(180, 180, 459, 259, "Esborrar tot");
		escriure(200, 200, 0, 15, "Segur que vols esborrar-ho tot");
		escriure(200, 210, 0, 15, "(no ho podrs recuperar)?");
		estat("[Esborrar]. Tria el bot desitjat.");
		i=hmenu(190, 239, sino, 2, 18*8);
		putimage(180, 180, oldb, COPY_PUT);
		free(oldb);
		if (i!=1)
		{
			memset(vector, 0, sizeof(vector));
			for (i=0; i<MAX_VECTOR; i++)
				inserir_fig_vector(i,ID_BUIT,-1,-1,-1,-1,-1,-1,"BUIT %u",-1,-1);
			index=0;
		}
	}
	else
	{
		memset(vector, 0, sizeof(vector));
		for (i=0; i<MAX_VECTOR; i++)
			inserir_fig_vector(i,ID_BUIT,-1,-1,-1,-1,-1,-1,"BUIT %u",-1,-1);
		index=0;
	}
	refrescar();

}

/* ------------------------ Esborrar una figura -------------------------- */
void pascal esborrar_figura (void)
{
	register int j;

	j=triarfigura(0);
	if (j>=0)
	{
		vector[j].afes=0;
		refrescar();
	}
}

/* --------------------- Esborrar una figura permanentment ---------------- */
void pascal esborrar_fig_permanent (void)
{
	register unsigned int i;
	int j, k;
	char *oldb;
	char sino[][21]={	"Esborrar figura",
							" Cancel.lar "};

	oldb=malloc(imagesize(180, 180, 459, 259));
	if (oldb==0)
		sortir(3);
	j=triarfigura(0);
	if (j>=0)
	{
		getimage(180, 180, 459, 259, oldb);
		caixa(180, 180, 459, 259, "Esborrar figura");
		escriure(200, 200, 0, 15, "Segur que la vols esborrar");
		escriure(200, 210, 0, 15, "(no la podrs recuperar)?");
		estat("[Esborrar]. Tria el bot desitjat.");
		i=hmenu(190, 239, sino, 2, 18*8);
		putimage(180, 180, oldb, COPY_PUT);
		free(oldb);
		if (i!=1)
		{
			if (vector[j].id==ID_POLIGONIREG)
			{
				while (j!=-1)
				{
					k=vector[j].next;
					inserir_fig_vector(j,ID_BUIT,-1,-1,-1,-1,-1,-1,"BUIT %u",-1,-1);
					j=k;
				}
			}
			else
				inserir_fig_vector(j,ID_BUIT,-1,-1,-1,-1,-1,-1,"BUIT %u",-1,-1);
		}
		refrescar();
	}
}

/* ------------------------ Desfer l'Esborrat d'una figura -------------------------- */
void pascal desfer_esborrat (void)
{
	register int j;

	j=triarfigura(1);
	if (j<0)
		return;
	else
	{
		vector[j].afes=1;
		refrescar();
	}
}

/* ----------------------- Retorna la figura cliqueada -------------------- */
int pascal triarfigura (unsigned int e)
{
	register unsigned int i;
	register int j=0;
	int x,y;
	unsigned register int correcta=0;
	char *oldb;
	char tmp[81];
	char menu[13][41];

	do
	{
		oldb=malloc(imagesize(190, 100, 449, 379));
		if (oldb==0)
			sortir(3);
		getimage(190, 100, 449, 379, oldb);
		caixa(190, 100, 449, 379, "Triar primitiva");
		estat("[Triar]. Marca la primitiva desitjada");
		strcpy(menu[10], "         Anterior         ");
		strcpy(menu[11], "         Segent          ");
		strcpy(menu[12], "        Cancel.lar        ");
		do
		{
			for (i=0; i!=10; i++)
			{
				memset(tmp, 0, 27);
				memset(tmp, 32, 26);
				if (vector[i+j].afes==0)
				{
					memcpy(tmp, vector[i+j].sim, strlen(vector[i+j].sim));
					memcpy(&tmp[21], "[Esb]", 5);
					strcpy(menu[i], tmp);
				}
				else
				{
					memcpy(tmp, vector[i+j].sim, strlen(vector[i+j].sim));
					strcpy(menu[i], tmp);
				}
			}
			i=vmenu(210, 125, menu, 13, 18);
			if (i==10)
				j-=10;
			else if (i==11)
				j+=10;
			if (j<0)
				j=0;
			if (j>MAX_VECTOR-1)
				j=MAX_VECTOR-10;
		}
		while ((i==10) || (i==11));
		putimage(190, 100, oldb, COPY_PUT);
		free(oldb);
		if (i==12)
		{
			j=-1;
			correcta=1;
		}
		else
		{
			if ((e==0) && (vector[j+i].id!=ID_BUIT) && (vector[j+i].id!=ID_POLIGONPART) && (vector[j+i].afes!=0))
			{
				dibuixar_figura(j+i,5);
				estat("[Triar]. Si s correcta pitja el bot esquerre del ratol, sin el dret.");
				cursor(&x, &y);
				if (x!=-1)
				{
					j=j+i;
					correcta=1;
				}
			}
			else
			{
				if ((e==1) && (vector[j+i].id!=ID_BUIT) && (vector[j+i].id!=ID_POLIGONPART))
				{
					dibuixar_figura(j+i,5);
					j=j+i;
					correcta=1;
				}
			}
		refrescar();
		}
	}
	while (correcta==0);
	return(j);
}

/* --------------- Men de les transformacions permeses ------------------ */
void pascal transformar (void)
{
	register int i;
	char *oldb;
	char menu[][41]={
										"         Copiar          ",
										"        Traslladar       ",
										"          Girar          ",
										"         Escalar         ",
										"       Cancel.lar        ",
									};

	estat("[Transformar] Marca la comanda desitjada");
	oldb=malloc(imagesize(190, 150, 449, 329));
	if (oldb==0)
		sortir(3);
	getimage(190, 150, 449, 329, oldb);
	caixa(190, 150, 449, 329, "Menu Transformar");
	i=vmenu(215, 190, menu, 5, 18);
	putimage(190, 150, oldb, COPY_PUT);
	free(oldb);
	if (i==0)
		copiar();
	else if (i==1)
		traslladar();
	else if (i==2)
		girar();
	else if (i==3)
		escalar();
}

/* ----------------------- Copiar una Figura ------------------------------ */
void pascal copiar (void)
{
	int i, j, x, y;

	j=triarfigura(0);
	if (j>=0)
	{
		estat("[Copiar] Marca el punt de dest que es prendr de referncia");
		cursor(&x, &y);
		if (x!=-1)
		{
			putpixel(x,y,12);
			switch (vector[j].id)
			{
				case ID_ARC:
						inserir_fig_vector(index,ID_ARC,x,y,vector[j].x2,-1,vector[j].a1,vector[j].a2,"ARC %u",-1,1);
						index++;
						break;

				case ID_CIRCUMFERENCIA:
						inserir_fig_vector(index,ID_CIRCUMFERENCIA,x,y,vector[j].x2,-1,-1,-1,"CIRCUMFERENCIA %u",-1,1);
						index++;
						break;

				case ID_ELIPSE:
						inserir_fig_vector(index,ID_ELIPSE,x,y,vector[j].x2,vector[j].y2,vector[j].a1,vector[j].a2,"EL.LIPSE %u",-1,1);
						index++;
						break;

				case ID_LINIA:
						inserir_fig_vector(index,ID_LINIA,x,y,vector[j].x2+(x-vector[j].x1),vector[j].y2+(y-vector[j].y1),-1,-1,"LINIA %u",-1,1);
						index++;
						break;

				case ID_POLIGONREG:
						inserir_fig_vector(index,ID_POLIGONREG,x,y,vector[j].x2+(x-vector[j].x1),vector[j].y2+(y-vector[j].y1),vector[j].a1,-1,"POLIGON REGULAR %u",-1,1);
						index++;
						break;

				case ID_POLIGONIREG:
						i=j+1;
						vector[index].id=ID_POLIGONIREG;
						vector[index].x1=x;
						vector[index].y1=y;
						vector[index].x2=-1;
						vector[index].y2=-1;
						vector[index].a1=-1;
						vector[index].a2=-1;
						sprintf(vector[index].sim, "POLIGON IRREGULAR %u", index);
						vector[index].afes=1;
						index++;
						while (vector[i].id==ID_POLIGONPART)
						{
							vector[index].id=ID_POLIGONPART;
							vector[index].x1=vector[i].x1+(x-vector[j].x1);
							vector[index].y1=vector[i].y1+(y-vector[j].y1);
							vector[index].x2=-1;
							vector[index].y2=-1;
							vector[index].a1=-1;
							vector[index].a2=-1;
							sprintf(vector[index].sim, "PART DE POLIGON %u", index);
							vector[index-1].next=index;
							i=vector[i].next;
							vector[index].afes=1;
							index++;
						}
						break;

				case ID_RECTANGLE:
						i=j+1;
						vector[index].id=ID_RECTANGLE;
						vector[index].x1=x;
						vector[index].y1=y;
						vector[index].x2=-1;
						vector[index].y2=-1;
						vector[index].a1=-1;
						vector[index].a2=-1;
						sprintf(vector[index].sim, "RECTANGLE %u", index);
						vector[index].afes=1;
						index++;
						while (vector[i].id==ID_POLIGONPART)
						{
							vector[index].id=ID_POLIGONPART;
							vector[index].x1=vector[i].x1+(x-vector[j].x1);
							vector[index].y1=vector[i].y1+(y-vector[j].y1);
							vector[index].x2=-1;
							vector[index].y2=-1;
							vector[index].a1=-1;
							vector[index].a2=-1;
							sprintf(vector[index].sim, "PART DE RECTANGLE %u", index);
							vector[index-1].next=index;
							i=vector[i].next;
							vector[index].afes=1;
							index++;
						}
						break;
/*						inserir_fig_vector(index,ID_RECTANGLE,x,y,vector[j].x2+(x-vector[j].x1),vector[j].y2+(y-vector[j].y1),-1,-1,"RECTANGLE %u",-1,1);
						index++;
						break;*/
			}
			refrescar();
		}
	}
}

/* --------------------- Traslladar una Figura ---------------------------- */
void pascal traslladar (void)
{
	int i, j, x, y;

	j=triarfigura(0);
	if (j>=0)
	{
		estat("[Traslladar] Marca el punt de dest que es prendr de referncia");
		cursor(&x, &y);
		if (x!=-1)
		{
			switch (vector[j].id)
			{
				case ID_LINIA:
				case ID_POLIGONREG:
						vector[j].x2+=(x-vector[j].x1);
						vector[j].y2+=(y-vector[j].y1);
						break;
				case ID_POLIGONIREG:
				case ID_RECTANGLE:
						i=j+1;
						while (vector[i].id==ID_POLIGONPART)
						{
							vector[i].x1+=(x-vector[j].x1);
							vector[i].y1+=(y-vector[j].y1);
							i=vector[i].next;
						}
						break;
			}
			vector[j].x1=x;
			vector[j].y1=y;
			refrescar();
		}
	}
}

/* -------------------------- Girar una Figura ---------------------------- */
void pascal girar (void)
{
	int i, j, tmpx, a;
	double angle;

	j=triarfigura(0);
	if (j>=0)
	{
		if (vector[j].id==ID_ELIPSE) /* || (vector[j].id==ID_RECTANGLE)) */
			avis("Ho sento, per la figura triada no es pot girar.");
		else
		{
			estat("[Girar] Entra l'angle de rotaci");
			numero(550, 470, &a, 1, 0, 360);
			angle=(a*PI)/180;
			switch (vector[j].id)
			{
				case ID_ARC:
						vector[j].a1-=a;
						vector[j].a2-=a;
						if (vector[j].a1<0)
							vector[j].a1=360+vector[j].a1;
						if (vector[j].a2<0)
							vector[j].a2=360+vector[j].a2;
						break;

			case ID_ELIPSE:
/*					x1=vector[j].x2;
					y1=0;
					x2=0;
					y2=vector[j].y2;
					tmpx=x1*cos(angle)+y1*(-sin(angle));
					y1=x1*sin(angle)+y1*cos(angle);
					x1=tmpx;
					vector[j].x2=sqrt(x1*x1+y1*y1);
					tmpx=x2*cos(angle)+y2*(-sin(angle));
					y2=x2*sin(angle)+y2*cos(angle);
					x2=tmpx;
					vector[j].y2=sqrt(x2*x2+y2*y2); */
					break;

				case ID_LINIA:
				case ID_POLIGONREG:
						vector[j].x2-=vector[j].x1;
						vector[j].y2-=vector[j].y1;
						tmpx=vector[j].x2*cos(angle)+vector[j].y2*(-sin(angle));
						vector[j].y2=vector[j].x2*sin(angle)+vector[j].y2*cos(angle);
						vector[j].x2=tmpx;
						vector[j].x2+=vector[j].x1;
						vector[j].y2+=vector[j].y1;
						break;

			case ID_POLIGONIREG:
			case ID_RECTANGLE:
						i=j+1;
						while (vector[i].id==ID_POLIGONPART)
						{
							vector[i].x1-=vector[j].x1;
							vector[i].y1-=vector[j].y1;
							tmpx=vector[i].x1*cos(angle)+vector[i].y1*(-sin(angle));
							vector[i].y1=vector[i].x1*sin(angle)+vector[i].y1*cos(angle);
							vector[i].x1=tmpx;
							vector[i].x1+=vector[j].x1;
							vector[i].y1+=vector[j].y1;
							i=vector[i].next;
						}
						break;
			}
			refrescar();
		}
	}
}

/* ----------------------- Escalar una Figura ----------------------------- */
void pascal escalar (void)
{
	int i, j, k, e;

	j=triarfigura(0);
	if (j>=0)
	{
		estat("[Escalar] Introdueix el percentatge d'escalament");
		numero(550, 470, &e, 25, 25, 400);
		switch (vector[j].id)
		{
			case ID_ARC:
			case ID_CIRCUMFERENCIA:
					vector[j].x2=(vector[j].x2*e)/100;
					break;

			case ID_ELIPSE:
					vector[j].x2=(vector[j].x2*e)/100;
					vector[j].y2=(vector[j].y2*e)/100;
					break;

			case ID_LINIA:
			case ID_POLIGONREG:
					vector[j].x2=((vector[j].x2-vector[j].x1)*e)/100+vector[j].x1;
					vector[j].y2=((vector[j].y2-vector[j].y1)*e)/100+vector[j].y1;
					break;

			case ID_POLIGONIREG:
			case ID_RECTANGLE:
					k=j;
					i=j+1;
					while (vector[i].id==ID_POLIGONPART)
					{
						vector[i].x1=(((vector[i].x1-vector[k].x1)*e)/100)+vector[k].x1;
						vector[i].y1=(((vector[i].y1-vector[k].y1)*e)/100)+vector[k].y1;
						i=vector[i].next;
					}
					break;
		}
		refrescar();
	}
}

/* --------- Compara si un punt s el principi o final d'una recta -------- */
void pascal	comparar_punts (int i, int linia, float xp, float yp, int err)
{
	int x, y, cont=0;
	char missatge[60];

	do
	{
		cursor(&x, &y);
		if (((x+err)>vector[i].x1) && ((x-err)<vector[i].x1) && ((y+err)>vector[i].y1) && ((y-err)<vector[i].y1))
		{
			inserir_fig_vector(i, ID_LINIA, vector[i].x1, vector[i].y1, xp, yp, -1, -1, "LINIA %u", -1, 1);
			cont=1;
		}
		else
		{
			if (((x+err)>vector[i].x2) && ((x-err)<vector[i].x2) && ((y+err)>vector[i].y2) && ((y-err)<vector[i].y2))
			{
				inserir_fig_vector(i, ID_LINIA, vector[i].x2, vector[i].y2, xp, yp, -1, -1, "LINIA %u", -1, 1);
				cont=1;
			}
			else
			{
				sprintf(missatge,"Tria el punt inicial o final de la %u LINIA, si us plau.", linia);
				avis(missatge);
			}
		}
	}
	while (cont==0);
}
/* ----------- Troba el punt mxim d'una lnia respecte l'entrat ---------- */
void pascal maxim_punt (int i, float x, float y, float m, float b)
{
	int y2;

	if ((abs(x-vector[i].x1))>=(abs(x-vector[i].x2)))
	{
		y2=m*vector[i].x1+b;
		inserir_fig_vector(i, ID_LINIA, vector[i].x1, y2, x, y, -1, -1, "LINIA %u", -1, 1);
	}
	else
	{
		y2=m*vector[i].x2+b;
		inserir_fig_vector(i, ID_LINIA, vector[i].x2, y2, x, y, -1, -1, "LINIA %u", -1, 1);
	}
}

/* -------------------- Menu dels Empalmaments permesos ------------------- */
void pascal empalmament (void)
{
	register int i;
	int x, y;
	char *oldb;
	char menu[][41]={
										"  Empalmament Rectilini  ",
										"  Empalmament amb Arc    ",
										"  Empalmament amb Xamfr ",
										"       Cancel.lar        ",
									};
	estat("[Empalmament] Marca la comanda desitjada");
	oldb=malloc(imagesize(190, 160, 449, 319));
	if (oldb==0)
		sortir(3);
	getimage(190, 160, 449, 319, oldb);
	caixa(190, 160, 449, 319, "Menu Empalmament");
	i=vmenu(215, 200, menu, 4, 18);
	putimage(190, 160, oldb, COPY_PUT);
	free(oldb);
	if (i==0)
		empalmament_rectilini(&x,&y);
	else if (i==1)
		empalmament_arc();
	else if (i==2)
		empalmament_xamfra();
}

/* -------------------- Empalmament d'una lnia --------------------------- */
void pascal empalmament_rectilini (int *ind1, int *ind2)
{
	int i, j, a=0, b=0;
	int x, y, xrmin, yrmin, xsmin, ysmin, xrmax, yrmax, xsmax, ysmax;
	float mr, ms, br, bs;

	i=triarfigura(0);
	while ((vector[i].id!=ID_LINIA) && (i>=0))
	{
		avis("Tria una LINIA, si us plau.");
		i=triarfigura(0);
	}
	if (i>=0)
	{
		j=triarfigura(0);
		while (((vector[j].id!=ID_LINIA) || (i==j)) && (j>=0))
		{
			if (i==j)
				avis("Tria una LINIA diferent de la primera, si us plau.");
			else
				avis("Tria una LINIA, si us plau.");
			j=triarfigura(0);
		}
		if (j>=0)
		{
			mr=(float) ((vector[i].y2-vector[i].y1))/(float) ((vector[i].x2-vector[i].x1));
			ms=(float) ((vector[j].y2-vector[j].y1))/(float) ((vector[j].x2-vector[j].x1));
			if (ms==mr)
			{
				avis("No es poden empalmar 2 rectes PARAL.LELES.");
				i=-1;
				j=-1;
			}
			else
			{
				br=vector[i].y1-mr*vector[i].x1;
				bs=vector[j].y1-ms*vector[j].x1;
				x=(br-bs)/(ms-mr);
				y=br+mr*x;

				xrmax=max(vector[i].x1,vector[i].x2);
				xrmin=min(vector[i].x1,vector[i].x2);
				yrmax=max(vector[i].y1,vector[i].y2);
				yrmin=min(vector[i].y1,vector[i].y2);
				xsmax=max(vector[j].x1,vector[j].x2);
				xsmin=min(vector[j].x1,vector[j].x2);
				ysmax=max(vector[j].y1,vector[j].y2);
				ysmin=min(vector[j].y1,vector[j].y2);

				if (((x>xrmin) && (x<xrmax)) || ((y>yrmin) && (y<yrmax)))
					a=1;
				if (((x>xsmin) && (x<xsmax)) || ((y>ysmin) && (y<ysmax)))
					b=1;

				if ((a==1) && (b==1))
				{
					estat("[Empalmament] Marca el punt de la 1 recta que vols conservar");
					comparar_punts(i,1,x,y,15);
					estat("[Empalmament] Marca el punt de la 2 recta que vols conservar");
					comparar_punts(j,2,x,y,15);
				}
				else
				{
					if ((a==1) || (b==1))
					{
						estat("[Empalmament] Marca el punt de la 1 recta que vols conservar");
						comparar_punts(i,1,x,y,15);
						maxim_punt(j,x,y,ms,bs);
					}
					else
					{
						maxim_punt(i,x,y,mr,br);
						maxim_punt(j,x,y,ms,bs);
					}
				}
				*ind1=i;
				*ind2=j;
				refrescar();
			}
		}
	}
}

/* ------------------------ Empalmament amb Arc --------------------------- */
void pascal empalmament_arc (void)
{
	int i, j, k, r, x1, y1, x2, y2;
	int op, or, p1x, p1y, /* p2x,*/ p2y, /* q1x,*/ q1y, /*q2x,*/ q2y;
	double x, y, mr, ms, br, bs, m2, b2, a1, a2;
	struct svector l1, l2;

	i=triarfigura(0);
	while ((vector[i].id!=ID_LINIA) && (i>=0))
	{
		avis("Tria una LINIA, si us plau.");
		i=triarfigura(0);
	}
	if (i>=0)
	{
		j=triarfigura(0);
		while (((vector[j].id!=ID_LINIA) || (i==j)) && (j>=0))
		{
			if (i==j)
				avis("Tria una LINIA diferent de la primera, si us plau.");
			else
				avis("Tria una LINIA, si us plau.");
			j=triarfigura(0);
		}
		if (j>=0)
		{
			estat("[Empalmament] Entra el radi de l'arc, per fer l'empalmament.");
			r=numero2(550,470);
			l1=calcul_paralela(i,j,r);
			l2=calcul_paralela(j,i,r);
			mr=(double) ((l1.y2-l1.y1))/(double) ((l1.x2-l1.x1));
			ms=(double) ((l2.y2-l2.y1))/(double) ((l2.x2-l2.x1));
			br=l1.y1-mr*l1.x1;
			bs=l2.y1-ms*l2.x1;
			x=(br-bs)/(ms-mr);
			y=br+mr*x;

			mr=(double) (vector[i].y2-vector[i].y1)/(double) (vector[i].x2-vector[i].x1);
			br=vector[i].y1-mr*vector[i].x1;
			m2=(double) (-1/mr);
			b2=y+((double) (1/mr))*x;
			x1=(b2-br)/(mr-m2);
			y1=br+mr*x1;
			if (distancia(x1,y1,vector[i].x1,vector[i].y1)>distancia(x1,y1,vector[i].x2,vector[i].y2))
			{
				vector[i].x2=x1;
				vector[i].y2=y1;
				k=0;
			}
			else
			{
				vector[i].x1=x1;
				vector[i].y1=y1;
				k=1;
			}

			ms=(double) (vector[j].y2-vector[j].y1)/(double) (vector[j].x2-vector[j].x1);
			bs=vector[j].y1-ms*vector[j].x1;
			m2=(double) (-1/ms);
			b2=y+((double) (1/ms))*x;
			x2=(b2-bs)/(ms-m2);
			y2=bs+ms*x2;
			putpixel(x2,y2,4);
			if (k==0)
			{
				if (distancia(vector[i].x1,vector[i].y1,vector[j].x1,vector[j].y1)>distancia(vector[i].x1,vector[i].y1,vector[j].x1,vector[j].y1))
				{
					vector[j].x1=x2;
					vector[j].y1=y2;
				}
				else
				{
					vector[j].x2=x2;
					vector[j].y2=y2;
				}
			}
			else
			{
				if (distancia(vector[i].x2,vector[i].y2,vector[j].x1,vector[j].y1)>distancia(vector[i].x2,vector[i].y2,vector[j].x2,vector[j].y2))
				{
					vector[j].x1=x2;
					vector[j].y1=y2;
				}
				else
				{
					vector[j].x2=x2;
					vector[j].y2=y2;
				}
			}

			if( vector[i].x1 > vector[i].x2 )
			{
				p1x=vector[i].x2; p1y=vector[i].y2;
				/* q1x=vector[i].x1 */; q1y=vector[i].y1;
			}
			else
			{
				p1x=vector[i].x1; p1y=vector[i].y1;
				/*q1x=vector[i].x2 */; q1y=vector[i].y2;
			}
			if( vector[j].x1 > vector[j].x2 )
			{
				/* p2x=vector[j].x2 */; p2y=vector[j].y2;
				/* q2x=vector[j].x1 */; q2y=vector[j].y1;
			}
			else
			{
				/* p2x=vector[j].x1 */; p2y=vector[j].y1;
				/* q2x=vector[j].x2 */; q2y=vector[j].y2;
			}

			if (p1x == vector[i].x1 && k==0)
				or=dret;
			if (p1x == vector[i].x1 && k==1)
				or=esq;
			if (p1x == vector[i].x2 && k==0)
				or=esq;
			if (p1x == vector[i].x2 && k==1)
				or=dret;

			if (or==dret && q1y < q2y) /* dir=de2a1; */
				op=1;
			if (or==dret && q1y > q2y) /*dir=de1a2;*/
				op=2;
			if (or==esq && p1y < p2y) /*dir=de1a2;*/
				op=3;
			if (or==esq && p1y > p2y) /*dir=de2a1;*/
				op=4;

			a1=atan(1/mr);
			a1=((a1*180)/PI);
			a2=atan(1/ms);
			a2=((a2*180)/PI);

			switch(op)
			{
				case 1:
					inserir_fig_vector(index,ID_ARC,x,y,r,-1,a2,a1,"ARC %u",-1,1);
					break;
				case 2:
					a1+=0; a2+=0;
					inserir_fig_vector(index,ID_ARC,x,y,r,-1,a1,a2,"ARC %u",-1,1);
					break;
				case 3:
					a1+=180; a2=360-a2;
					inserir_fig_vector(index,ID_ARC,x,y,r,-1,a1,a2,"ARC %u",-1,1);
					break;
				case 4:
					a1+=180; a2+=180;
					inserir_fig_vector(index,ID_ARC,x,y,r,-1,a2,a1,"ARC %u",-1,1);
					break;
			}
			index++;
			refrescar();
		}
	}
}

/* -------------------- Calcula la distncia entre 2 punts ---------------- */
int pascal distancia (int x1, int y1, int x2, int y2)
{
	int n;

	n=sqrt(pow(x1-x2,2)+pow(y1-y2,2));
	return n;
}

/* --------------- Clcul de la lnia paral.lela a la donada -------------- */
struct svector pascal calcul_paralela (int i, int j, int r)
{
	struct svector p1, p2;
	int x, y;
	double m, a;

	m=(double) (vector[i].y2-vector[i].y1)/(double) (vector[i].x2-vector[i].x1);
	a=atan(m);

	x=r*cos(a+(PI/2));
	y=r*sin(a+(PI/2));
	p1.x1=vector[i].x1+x;
	p1.y1=vector[i].y1+y;
	p1.x2=vector[i].x2+x;
	p1.y2=vector[i].y2+y;

	x=r*cos(a-(PI/2));
	y=r*sin(a-(PI/2));
	p2.x1=vector[i].x1+x;
	p2.y1=vector[i].y1+y;
	p2.x2=vector[i].x2+x;
	p2.y2=vector[i].y2+y;

//	dist1=sqrt(pow(p1.x1-vector[j].x1,2)+pow(p1.y1-vector[j].y1,2));
//	dist2=sqrt(pow(p2.x1-vector[j].x1,2)+pow(p2.y1-vector[j].y1,2));
	if (distancia(p1.x1,p1.y1,vector[j].x1,vector[j].y1)>distancia(p2.x1,p2.y1,vector[j].x1,vector[j].y1))
	{
		p1=p2;
	}
	return p1;
}

/* ------------------------ Empalmament amb Xamfr ------------------------ */
void pascal empalmament_xamfra (void)
{
	int i, j, n1, n2;
	float a;

	empalmament_rectilini(&i,&j);
	if ((i>=0) && (j>=0))
	{
		estat("[Empalmament] Entra la distncia de la 1 recta.");
		n1=numero2(550,470);
		estat("[Empalmament] Entra la distncia de la 2 recta.");
		n2=numero2(550,470);
		if ((vector[i].x1==vector[j].x1) && (vector[i].y1==vector[j].y1))
		{
			a=atan((float) (vector[i].y2-vector[i].y1)/(float) (vector[i].x2-vector[i].x1));
			if (vector[i].x2>vector[i].x1)
			{
				vector[i].x1+=n1*cos(a+PI);
				vector[i].y1+=n1*sin(a+PI);
			}
			else
			{
				vector[i].x1-=n1*cos(a+PI);
				vector[i].y1-=n1*sin(a+PI);
			}
			a=atan((float) (vector[j].y2-vector[j].y1)/(float) (vector[j].x2-vector[j].x1));
			if (vector[j].x2>vector[j].x1)
			{
				vector[j].x1+=n2*cos(a+PI);
				vector[j].y1+=n2*sin(a+PI);
			}
			else
			{
				vector[j].x1-=n2*cos(a+PI);
				vector[j].y1-=n2*sin(a+PI);
			}
			inserir_fig_vector(index,ID_LINIA,vector[i].x1,vector[i].y1,vector[j].x1,vector[j].y1,-1,-1,"LINIA %u",-1,1);
		}
		else
		{
			if ((vector[i].x1==vector[j].x2) && (vector[i].y1==vector[j].y2))
			{
				a=atan((float) (vector[i].y2-vector[i].y1)/(float) (vector[i].x2-vector[i].x1));
				if (vector[i].x2>vector[i].x1)
				{
					vector[i].x1+=n1*cos(a+PI);
					vector[i].y1+=n1*sin(a+PI);
				}
				else
				{
					vector[i].x1-=n1*cos(a+PI);
					vector[i].y1-=n1*sin(a+PI);
				}
				a=atan((float) (vector[j].y2-vector[j].y1)/(float) (vector[j].x2-vector[j].x1));
				if (vector[j].x2>vector[j].x1)
				{
					vector[j].x2+=n2*cos(a+PI);
					vector[j].y2+=n2*sin(a+PI);
				}
				else
				{
					vector[j].x2-=n2*cos(a+PI);
					vector[j].y2-=n2*sin(a+PI);
				}
				inserir_fig_vector(index,ID_LINIA,vector[i].x1,vector[i].y1,vector[j].x2,vector[j].y2,-1,-1,"LINIA %u",-1,1);
			}
			else
			{
				if ((vector[i].x2==vector[j].x1) && (vector[i].y2==vector[j].y1))
				{
					a=atan((float) (vector[i].y2-vector[i].y1)/(float) (vector[i].x2-vector[i].x1));
					if (vector[i].x2>vector[i].x1)
					{
						vector[i].x2+=n1*cos(a+PI);
						vector[i].y2+=n1*sin(a+PI);
					}
					else
					{
						vector[i].x2-=n1*cos(a+PI);
						vector[i].y2-=n1*sin(a+PI);
					}
					a=atan((float) (vector[j].y2-vector[j].y1)/(float) (vector[j].x2-vector[j].x1));
					if (vector[j].x2>vector[j].x1)
					{
						vector[j].x1+=n2*cos(a+PI);
						vector[j].y1+=n2*sin(a+PI);
					}
					else
					{
						vector[j].x1-=n2*cos(a+PI);
						vector[j].y1-=n2*sin(a+PI);
					}
					inserir_fig_vector(index,ID_LINIA,vector[i].x2,vector[i].y2,vector[j].x1,vector[j].y1,-1,-1,"LINIA %u",-1,1);
				}
				else
				{
					a=atan((float) (vector[i].y2-vector[i].y1)/(float) (vector[i].x2-vector[i].x1));
					if (vector[i].x2>vector[i].x1)
					{
						vector[i].x2+=n1*cos(a+PI);
						vector[i].y2+=n1*sin(a+PI);
					}
					else
					{
						vector[i].x2-=n1*cos(a+PI);
						vector[i].y2-=n1*sin(a+PI);
					}
					a=atan((float) (vector[j].y2-vector[j].y1)/(float) (vector[j].x2-vector[j].x1));
					if (vector[j].x2>vector[j].x1)
					{
						vector[j].x2+=n2*cos(a+PI);
						vector[j].y2+=n2*sin(a+PI);
					}
					else
					{
						vector[j].x2-=n2*cos(a+PI);
						vector[j].y2-=n2*sin(a+PI);
					}
					inserir_fig_vector(index,ID_LINIA,vector[i].x2,vector[i].y2,vector[j].x2,vector[j].y2,-1,-1,"LINIA %u",-1,1);
				}
			}
		}
		index++;
		refrescar();
	}
}