/********** includes **********/
#include <stdio.h>
#include <stdlib.h>
#include <graphics.h>
#include <dos.h>
#include "libgraf.h"
#include "ratoli.h"


/********** Prototipus de les accions i funcions **********/
Pol2D CreaPoligon (void);
Window CalculaWindow (Capsa2D);
Viewport CalculaViewport (int, int, int, int);
void Visualitza (Pol2D, mat3x3);

void main (void)
{
	int graphdriver, graphmode;
	Pol2D pol;
	Capsa2D capsa;
	Window win;
	Viewport view;
	mat3x3 mat;
	int x, y, boto;
	Pt2D p;
	PtDisp pd;

	detectgraph (&graphdriver, &graphmode);

	if (graphdriver<0)
	{
		printf("No s'ha detectat hard grfic.");
		exit(1);
	}
	printf("Driver grfic nm.%d mode %d.", graphdriver, graphmode);
	initgraph(&graphdriver, &graphmode, "");

	randomize();
	pol=CreaPoligon();
	capsa=CapsaMinContPol2D(pol);
	win=CalculaWindow(capsa);
	x=getmaxx();
	y=getmaxy();

	view=CalculaViewport(0,0, x, y);
	CreaMatTmd(win,view,mat);
	cleardevice();
	Visualitza(pol,mat);
	do
	{
		RequestLocatorRatoli(&pd.x, &pd.y, &boto);
		CreaMatTdm(win,view,mat);
		p=TrDispMon(pd, mat);
		settextstyle(DEFAULT_FONT, HORIZ_DIR, 2);
		setfillstyle(SOLID_FILL, BLACK);
		bar(0, 0, (44-26)*16, 16);
		setcolor(WHITE);
		if (PtIntPol2D(p, pol))
			outtextxy(0, 0, "El punt s interior");
		else
			outtextxy(0, 0, "El punt s exterior");
		}
    while (boto!=BOTO_DRET);
		closegraph();
}

Pol2D CreaPoligon (void)
{
	int boto;
	mat3x3 mat;
	Pol2D pol;
	PtDisp pd, pd2, pdaux;
	Window win;

	win.vmin.x=0;
	win.vmax.x=100;
	win.vmin.y=0;
	win.vmax.y=100;

	CreaMatTdm(win, CalculaViewport(1, 1, getmaxx(), getmaxy()), mat);
	IniLocatorRatoli(getmaxx()>>1, getmaxy()>>1, CalculaViewport(1, 1, getmaxx(), getmaxy()));
	pol.nv=0;
	RequestLocatorRatoli(&pd.x, &pd.y, &boto);
	pol.v[pol.nv]=TrDispMon(pd, mat);
	pol.nv++;
	pd2=pd;
	pdaux=pd2;
	setwritemode(XOR_PUT);

	do
	{
		MostraRatoli();
		SampleLocatorRatoli(&pd2.x, &pd2.y, &boto);
		if ((pdaux.x!=pd2.x) || (pdaux.y!=pd2.y))
		{
			AmagaRatoli();
			line(pd.x, pd.y, pdaux.x, pdaux.y);
			line(pd.x, pd.y, pd2.x, pd2.y);
			pdaux=pd2;
			MostraRatoli();
		}
		if (boto==BOTO_ESQUERRE)
		{
			pol.v[pol.nv]=TrDispMon(pd2, mat);
			pol.nv++;
			pd=pd2;
		}
	}
	while(boto!=BOTO_DRET);
	AmagaRatoli();
	setwritemode(COPY_PUT);
	return(pol);
}

Window CalculaWindow (Capsa2D capsa)
{
	Window win;
	float alcada, amplada;

	amplada=capsa.vmax.x-capsa.vmin.x;
	amplada=(amplada*5)/100;
	win.vmin.x=capsa.vmin.x-amplada;
	win.vmax.x=capsa.vmax.x+amplada;
	alcada=capsa.vmax.y-capsa.vmin.y;
	alcada=(alcada*5)/100;
	win.vmin.y=capsa.vmin.y-alcada;
	win.vmax.y=capsa.vmax.y+alcada;

	return(win);
}

Viewport CalculaViewport (int esquerra, int inf, int dreta, int sup)
{
	Viewport view;

	view.vmin.x=esquerra;
	view.vmin.y=inf;
	view.vmax.x=dreta;
	view.vmax.y=sup;

	return (view);
}

void Visualitza (Pol2D pol, mat3x3 mat)
{
	unsigned int i;
	PtDisp p;
	int num, poligon[2*MAXVER];

	for (i=0; i<pol.nv; i++)
	{
		p=TrMonDisp(pol.v[i], mat);
		poligon[2*i]=p.x;
		poligon[2*i+1]=p.y;
	}
	poligon[2*i]=poligon[0];
	poligon[2*i+1]=poligon[1];
	pol.nv++;
	while ((num=random(15)+1)==WHITE);
	setfillstyle(SOLID_FILL, num);
	fillpoly(pol.nv, poligon);
}
