/********** includes **********/
#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include <graphics.h>
#include "libgraf.h"
#include "ratoli.h"
#include "teclat.h"
#include "Pol3D.h"

#define PI 3.14159
#define PI10 0.314159
#define PI100 0.0314159


/********** Prototipus de les accions i funcions **********/
Pol2D CreaPoligon (void);
Vec3D EntraVectorTranslacio (void);
Window CalculaWindow (Capsa2D);
Window WindowDonat (void);
Viewport CalculaViewport (int, int, int, int);
Capsa3D CapsaMinContPol3D (Pol3D p);
void Visualitza(Pol3D p3, Capsa3D c3, float giry, float girx, int axo, float dist);
void DibuixaPoliedre(Pol3D p3, Capsa3D c3);
void Visualitza2D (Pol2D, mat3x3);

int numero (unsigned int, unsigned int);


void main (void)
{
	int graphdriver, graphmode;
	Pol2D pol;
//	Capsa2D capsa;
//	Window win;
//	Viewport view;
	Vec3D vec;
	boolea status, axo;
	int opc, d;
	Pol3D pol3;
	Capsa3D c3;
	float girx=0, giry=0;

	detectgraph (&graphdriver, &graphmode);

	if (graphdriver<0)
	{
		printf("No s'ha detectat hard grfic.");
		exit(1);
	}
	printf("Driver grfic nm.%d mode %d.", graphdriver, graphmode);
	initgraph(&graphdriver, &graphmode, "");

	randomize();
	pol=CreaPoligon();
	vec=EntraVectorTranslacio();

	pol3=Translacional (pol, vec);
	c3=CapsaMinContPol3D (pol3);
	d=20*(c3.vmax.z-c3.vmin.z);
	axo=FALS;
	do
	{
		cleardevice();
		Visualitza(pol3, c3, giry, girx, axo, d);
		RequestChoiceTeclat(&opc, &status);
		switch(opc)
		{
			case C_FAMUNT: girx+=PI10;
										 break;

			case C_FAVALL: girx-=PI10;
										 break;

			case C_FESQ: giry+=PI10;
									 break;

			case C_FDRETA: giry-=PI10;
										 break;

			case 'A':
			case 'a':      axo=!axo;
										 break;

			case '-':      d+=((c3.vmax.z-c3.vmin.z));
										 break;

			case '+':      d-=((c3.vmax.z-c3.vmin.z));
										 break;
		}
		if (girx>2*PI)
			girx=0;
		else if (girx<0)
			girx=2*PI;
		if (giry>2*PI)
			giry=0;
		else if (giry<0)
			giry=2*PI;
		if (d<(c3.vmax.z-c3.vmin.z)*2)
			d=(c3.vmax.z-c3.vmin.z)*2;
		else if (d>(20*(c3.vmax.z-c3.vmin.z)))
			d=20*(c3.vmax.z-c3.vmin.z);
	}
	while(opc!=C_ESCAPE);
	closegraph();
}

Window WindowDonat (void)
{
	Window win;

	win.vmin.x=0;
	win.vmax.x=100;
	win.vmin.y=0;
	win.vmax.y=100;
	return(win);
}

Pol2D CreaPoligon (void)
{
	int boto;
	mat3x3 mat;
	Pol2D pol;
	PtDisp pd, pd2, pdaux;
	Window win;

	win=WindowDonat();

	CreaMatTdm(win, CalculaViewport(1, 1, getmaxx(), getmaxy()), mat);
	IniLocatorRatoli(getmaxx()>>1, getmaxy()>>1, CalculaViewport(1, 1, getmaxx(), getmaxy()));
	pol.nv=0;
	RequestLocatorRatoli(&pd.x, &pd.y, &boto);
	pol.v[pol.nv]=TrDispMon(pd, mat);
	pol.nv++;
	pd2=pd;
	pdaux=pd2;
	setwritemode(XOR_PUT);

	do
	{
		MostraRatoli();
		SampleLocatorRatoli(&pd2.x, &pd2.y, &boto);
		if ((pdaux.x!=pd2.x) || (pdaux.y!=pd2.y))
		{
			AmagaRatoli();
			line(pd.x, pd.y, pdaux.x, pdaux.y);
			line(pd.x, pd.y, pd2.x, pd2.y);
			pdaux=pd2;
			MostraRatoli();
		}
		if (boto==BOTO_ESQUERRE)
		{
			pol.v[pol.nv]=TrDispMon(pd2, mat);
			pol.nv++;
			pd=pd2;
		}
	}
	while(boto!=BOTO_DRET);
	AmagaRatoli();
	setwritemode(COPY_PUT);
	return(pol);
}

Window CalculaWindow (Capsa2D capsa)
{
	Window win;
	float alcada, amplada;

	amplada=capsa.vmax.x-capsa.vmin.x;
	amplada=(amplada*5)/100;
	win.vmin.x=capsa.vmin.x-amplada;
	win.vmax.x=capsa.vmax.x+amplada;
	alcada=capsa.vmax.y-capsa.vmin.y;
	alcada=(alcada*5)/100;
	win.vmin.y=capsa.vmin.y-alcada;
	win.vmax.y=capsa.vmax.y+alcada;

	return(win);
}

Viewport CalculaViewport (int esquerra, int inf, int dreta, int sup)
{
	Viewport view;

	view.vmin.x=esquerra;
	view.vmin.y=inf;
	view.vmax.x=dreta;
	view.vmax.y=sup;

	return (view);
}

void Visualitza2D (Pol2D pol, mat3x3 mat)
{
	unsigned int i;
	PtDisp p;
	int poligon[2*MAXVER];

	for (i=0; i<pol.nv; i++)
	{
		p=TrMonDisp(pol.v[i], mat);
		poligon[2*i]=p.x;
		poligon[2*i+1]=p.y;
	}
	poligon[2*i]=poligon[0];
	poligon[2*i+1]=poligon[1];
	pol.nv++;
	drawpoly(pol.nv, poligon);
}

int numero (unsigned int x, unsigned int y)
{
	int m=0, n;
	char tmp[80];

	sprintf(tmp, "%8d", m);
	outtextxy(x, y, tmp);
	n=getch();
	while (n!=13)
	{
		if ((n>'0') && (n<'9'))
		{
			m=(n-'0')+m*10;
			sprintf(tmp, "%8d", m);
			outtextxy(x, y, tmp);
		}
		else if (n==8)
		{
			m=m / 10;
			sprintf(tmp, "%8d", m);
			outtextxy(x, y, tmp);
		}
		n=getch();
	}
	return (m);
}


Vec3D EntraVectorTranslacio (void)
{

//	int tmp;
	Vec3D v;
/*
	outtextxy(10, 10, "Vector de translacio");
	outtextxy(20, 30, "X=");
	tmp=numero(50, 30);
	v.vx=(int) tmp;
	outtextxy(20, 50, "Y=");
	tmp=numero(50, 50);
	v.vy=(int) tmp;
	outtextxy(20, 70, "Z=");
	tmp=numero(50, 70);
	v.vz=(int) tmp;
	return(v);
	*/
	v.vx=0;
	v.vy=0;
	v.vz=20;
	return(v);
}

Capsa3D CapsaMinContPol3D (Pol3D p)
{
	register unsigned int i;
	Capsa3D c;

	c.vmin.x=p.vert[0].x;
	c.vmax.x=p.vert[0].x;
	c.vmin.y=p.vert[0].y;
	c.vmax.y=p.vert[0].y;
	c.vmin.z=p.vert[0].z;
	c.vmax.z=p.vert[0].z;

	for (i=1; i!=p.nv; i++)
	{
		c.vmin.x=min(c.vmin.x,p.vert[i].x);
		c.vmax.x=max(c.vmax.x,p.vert[i].x);
		c.vmin.y=min(c.vmin.y,p.vert[i].y);
		c.vmax.y=max(c.vmax.y,p.vert[i].y);
		c.vmin.z=min(c.vmin.z,p.vert[i].z);
		c.vmax.z=max(c.vmax.z,p.vert[i].z);
	}
	return(c);
}

void Visualitza(Pol3D p3, Capsa3D c3, float giry, float girx, int axo, float dist)
{
	int i;
	Vec3D cop;
	mat4x4 m1, m2;
	vector4 v4, vt4;

	/* Calculamos el Center Of Pan */
	cop.vx=(c3.vmin.x+c3.vmax.x)/2;
	cop.vy=(c3.vmin.y+c3.vmax.y)/2;
	cop.vz=(c3.vmin.z+c3.vmax.z)/2;
	c3.vmin.x-=cop.vx;
	c3.vmax.x-=cop.vx;
	c3.vmin.y-=cop.vy;
	c3.vmax.y-=cop.vy;
	c3.vmin.z-=cop.vz;
	c3.vmax.z-=cop.vz;

	CreaMatTranslacio3D(-cop.vx, -cop.vy, -cop.vz, m1);
	CreaMatGir3DY(giry, m2);
	ConcatMat4x4(m1, m2);
	CreaMatGir3DX(girx, m2);
	ConcatMat4x4(m1, m2);
	if (axo)
	{
		/* Matriu de deformacio */
		setviewport(0,0,getmaxx(),getmaxy(),1);
		Identitat4x4(m2);
		m2[2][3]=-(1/dist);
		ConcatMat4x4(m1, m2);
		setcolor(10);
		outtextxy(0,0,"Axonomtrica");
	}
	else
	{
		setviewport(0,0,getmaxx(),getmaxy(),1);
		setcolor(10);
		outtextxy(0,0,"            ");
		outtextxy(0,0,"Cnica");
	}

	for (i=0; i!=p3.nv; i++)
	{
		v4[0]=p3.vert[i].x;
		v4[1]=p3.vert[i].y;
		v4[2]=p3.vert[i].z;
		v4[3]=1;
		ProdMatVect4(v4, m1, vt4);
		p3.vert[i].x=vt4[0]/vt4[3];
		p3.vert[i].y=vt4[1]/vt4[3];
		p3.vert[i].z=vt4[2]/vt4[3];
	}
	DibuixaPoliedre(p3, c3);
}

void DibuixaPoliedre(Pol3D p3, Capsa3D c3)
{
	int nc, na, aux;
	Capsa2D c2;
	Pol2D p2;
	Window w;
	Viewport vp;
	mat3x3 M;

	c2.vmin.x=c3.vmin.x;
	c2.vmax.x=c3.vmax.x;
	c2.vmin.y=c3.vmin.y;
	c2.vmax.y=c3.vmax.y;

	w=CalculaWindow(c2);
	vp=CalculaViewport(0, 0, getmaxx(), getmaxy());
	CreaMatTmd(w, vp, M);

	for (nc=0; nc!=p3.nc; nc++)
	{
		for (na=0; na!=p3.car[nc].na; na++)
		{
			aux=p3.ares[p3.car[nc].pa+na];
			p2.v[na].x=p3.vert[aux].x;
			p2.v[na].y=p3.vert[aux].y;
		}
		p2.nv=na;
		Visualitza2D(p2, M);
	}
}
