/* teclat.h */

/* Valors ocults de retorn per RequestLocator */
#define RL_ESCAPE   ((char)1)
#define RL_SPACE    ((char)2)
#define RL_RETURN   ((char)3)

/* Valors de les tecles especials que retornen RequestChocie i SampleChoice */
#define C_F1 1
#define C_F2 2
#define C_F3 3
#define C_F4 4
#define C_F5 5
#define C_F6 6
#define C_F7 7
#define C_F8 8
#define C_F9 9
#define C_F10 10
#define C_CTRL_FESQ   11
#define C_CTRL_FDRETA 12
#define C_RETURN 13
#define C_FAMUNT 14
#define C_FAVALL 15
#define C_FESQ   16
#define C_FDRETA 17
#define C_SHIFT_FAMUNT 18
#define C_SHIFT_FAVALL 19
#define C_SHIFT_FESQ   20
#define C_SHIFT_FDRETA 21
#define C_INICIO 22
#define C_FIN    23
#define C_REPAG  24
#define C_AVPAG  25
#define C_DELETE 26
#define C_ESCAPE 27
#define C_BACKSPACE 28


/*****************************************************************
 *   Inicialitza el dispositiu Locator. Cal cridar aquesta funci
 *   almenys una vegada abans d'utilitzar el primer RequestLocatorTeclat.
 *
 *   x,y: Coordenades inicials del cursor
 *    vp: viewport per on es mour el cursor
 *   inc: Pas inicial del cursor
 *****************************************************************/
void IniLocatorTeclat( int x, int y, Viewport vp, int inc );


/*****************************************************************
 *   Demana un punt via el cursor. El punt cal confirmar-lo
 *   amb RETURN, ESC, o SPACE. El cursor es belluga amb les
 *   tecles del cursor. Amb les tecles + i - es pot variar la
 *   velocitat del moviment del cursor.
 *
 *    x,y: Retorna les coordenades del punt seleccionat
 *   conf: Retorna el carcter amb que s'ha confirmat
 *             RL_ESCAPE
 *             RL_SPACE
 *             RL_RETURN
 *****************************************************************/
void RequestLocatorTeclat( int *x, int *y, char *conf );


/*****************************************************************
 *  Demana una opci mitjanant el teclat (en realitat demana la
 *  polsaci d'una sola tecla o combinada amb SHIFT, CTRL o ALT).
 *
 *    opc: Retorna el codi de la tecla polsada (codi ASCII si s un
 *           carcter imprimible o el codi de la tecla especial).
 * status: Retorna CERT.
 *****************************************************************/
void RequestChoiceTeclat( int *opc, boolea *status );


/*****************************************************************
 *  Mira si s'ha triat una opci mitjanant el teclat (en realitat mira
 *  si s'ha polsat una sola tecla o combinada amb SHIFT, CTRL o ALT).
 *
 *    opc: Retorna el codi de la tecla polsada (codi ASCII si s un
 *           carcter imprimible o el codi de la tecla especial).
 * status: Retorna CERT si s'ha produt l'entrada. FALS en cas contrari.
 *****************************************************************/
void SampleChoiceTeclat( int *opc, boolea *status );
