#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <bios.h>
#include <time.h>
#include <io.h>
#include <dos.h>
#include "netgen.h"
#include "netipx.h"


#define SOCKET_CLIENTE 	0x5005
#define SOCKET_SERVIDOR 0x6006
#define TRAMA_ABRIR 	0
#define TRAMA_CERRAR	1
#define TRAMA_PONER 	2
#define TRAMA_COGER		3



IPXADDRESS ac, as;
IPXHEADER hc, hs;
IPXECB ec, es;

void _fastcall copyright (void);
void _fastcall cliente (void);
void _fastcall servidor (void);
void _fastcall ayuda (void);
void _fastcall salir (unsigned char);
void _fastcall abrirc (char *);
void _fastcall abrirs (char *);
void _fastcall cerrarc (void);
void _fastcall cerrars (void);
void _fastcall ejecutar (char *);
void _fastcall ayudac (void);
void _fastcall menu (void);
void _fastcall ayudam (void);
void _fastcall ponerc (char *cad);
void _fastcall cogerc (char *cad);
void _fastcall poners (char *cad);
void _fastcall cogers (char *cad);


void main (unsigned char argc, char *argv[])
{
	copyright();
	if (argc<2)
		menu();
	strupr(argv[1]);
	if (memcmp(argv[1], "/S", 2)==0)
		servidor();
	else if (memcmp(argv[1], "/C", 2)==0)
		cliente();
	else if (memcmp(argv[1], "/?", 2)==0)
		ayuda();
	else
		salir(2);
	salir(0);
}

void _fastcall copyright (void)
{
	puts("NET2NET R1.00.        Un aplicativo de traspaso de ficheros por IPX");
	puts("                      (c) Copyright 1998 por Bernardino Casas Fernndez");
	puts("                                       y por Javier Gutirrez Chamorro\n");
}

void _fastcall cliente (void)
{
	unsigned long l;
	char cad[256];


	puts("Actuando como CLIENTE");
	l=ipxinit();
	if (l==0)
		salir(3);
	ipxgetaddress(&ac);
	printf("Direccin local: %02X%02X%02X%02X:%02X%02X%02X%02X%02X%02X\n",
				 ac.netadd[0], ac.netadd[1], ac.netadd[2], ac.netadd[3], ac.nodeadd[0],
				 ac.nodeadd[1], ac.nodeadd[2], ac.nodeadd[3], ac.nodeadd[4],
				 ac.nodeadd[5]);

	do
	{
		printf("$ ");
		gets(cad);
		strupr(cad);
		if (memcmp(cad, "OPEN", 4)==0)
			abrirc(&cad[5]);
		else if (memcmp(cad, "CONNECT", 7)==0)
			abrirc(&cad[8]);
		else if (memcmp(cad, "GET", 3)==0)
			cogerc(&cad[4]);
		else if (memcmp(cad, "PUT", 3)==0)
			ponerc(&cad[4]);
		else if (memcmp(cad, "RUN", 3)==0)
			ejecutar(&cad[4]);
		else if ((memcmp(cad, "BYE", 3)==0) || (memcmp(cad, "CLOSE", 5)==0))
			cerrarc();
		else if ((memcmp(cad, "QUIT", 4)==0) || (memcmp(cad, "EXIT", 4)==0))
			cerrarc();
		else if ((memcmp(cad, "HELP", 4)==0) || (memcmp(cad, "?", 1)==0))
			ayudac();
		else
			puts("Comando no reconocido");
	}
	while ((memcmp(cad, "QUIT", 4)!=0) && (memcmp(cad, "EXIT", 4)!=0));
}

void _fastcall servidor (void)
{
	register unsigned char c;
	unsigned int tecla;
	unsigned long l;
	char trama[80];

	puts("Actuando como SERVIDOR");
	l=ipxinit();
	if (l==0)
		salir(3);
	ipxgetaddress(&as);
	printf("Direccin local: %02X%02X%02X%02X:%02X%02X%02X%02X%02X%02X\n",
					as.netadd[0], as.netadd[1], as.netadd[2], as.netadd[3], as.nodeadd[0],
					as.nodeadd[1], as.nodeadd[2], as.nodeadd[3], as.nodeadd[4],
					as.nodeadd[5]);


	as.socket=ipxreverseword(SOCKET_SERVIDOR);
	/* Abrimos un socket */
	c=ipxopensocket(0, &as.socket);
	if (c==0)
		printf("Conexin abierta por el socket %04X\n", ipxreverseword(as.socket));
	else if (c==0xFE)
		puts("No hay sockets disponibles");
	else if (c==0xFF)
		puts("Socket ya abierto");
	else
		puts("Conexin o abierta");

	do
	{
		tecla=bioskey(1);
		if (tecla!=0)
			tecla=bioskey(0);

		memset(&hc, 0, sizeof(hc));
		memset(&hs, 0, sizeof(hs));
		memset(&ec, 0, sizeof(ec));
		memset(&es, 0, sizeof(es));
		es.inuse=0x1D;
		es.socket=ipxreverseword(SOCKET_SERVIDOR);
		es.fragcount=2;
		es.fragaddr1=&hs;
		es.fragsize1=sizeof(IPXHEADER);
		es.fragaddr2=trama;
		es.fragsize2=sizeof(trama);
		ipxlistenforpacket(&es);
		while (es.inuse!=0)
		{
			ipxrelenquishcontrol();
		}
		switch (trama[0])
		{
			case TRAMA_ABRIR:
				abrirs(&trama[1]);
				break;
			case TRAMA_CERRAR:
				cerrars();
				break;
			case TRAMA_COGER:
				cogers(&trama[1]);
				break;
			case TRAMA_PONER:
				poners(&trama[1]);
				break;
			default:
				printf("Comando remoto no vlido (%u)\n", trama[0]);
		}
	}
	while (tecla!=0x11B);
}

void _fastcall ayuda (void)
{
	puts("  NET2NET es un programa diseado para poder enviar y recibir ficheros");
	puts("usando el protocolo IPX.\n");
	puts("Uso: NET2NET </C|/S|/?>\n");
	puts("     /C:     Actua como cliente");
	puts("     /S:     Actua como servidor");
	puts("     /?:     Muestra la ayuda");
	salir(200);
}


void _fastcall salir (unsigned char e)
{
	if (e==0)
		puts("Ejecucin terminada");
	else if (e==1)
		puts("Nmero de argumentos insuficiente");
	else if (e==2)
		puts("Parmetro incorrecto");
	else if (e==3)
		puts("IPX no instalado");
	exit(e);
}

/* ------------------------- Abre conexin -------------------------------- */
void _fastcall abrirc (char *cad)
{
	register unsigned char c;
	register unsigned int i;
//	char tmp[3];
	char trama[80];

	ac.socket=ipxreverseword(SOCKET_CLIENTE);
	/* Abrimos un socket */
	c=ipxopensocket(0, &ac.socket);
	if (c==0)
		printf("Conexin abierta por el socket %04X\n", ipxreverseword(ac.socket));
	else if (c==0xFE)
		puts("No hay sockets disponibles");
	else if (c==0xFF)
		puts("Socket ya abierto");
	else
		puts("Conexin o abierta");

	/* Le envamos al servido la peticin de apertura */
	memset(&hc, 0, sizeof(hc));
	memset(&hs, 0, sizeof(hs));
	memset(&ec, 0, sizeof(ec));
	memset(&es, 0, sizeof(es));
	ec.socket=ipxreverseword(SOCKET_CLIENTE);
	ec.fragcount=2;
	ec.fragaddr1=&hc;
	ec.fragsize1=sizeof(IPXHEADER);
	ec.fragaddr2=trama;
	ec.fragsize2=sizeof(trama);
	for (i=0; i!=12; i+=2)
		hc.dest.nodeadd[i>>1]=hex2int(&cad[i]);
	memcpy(&ec.immedaddr, &hc.dest.nodeadd, 6);
	hc.checksum=0xFFFF;
	hc.type=4;
	memset(hc.dest.netadd, 0, 4);
	hc.dest.socket=ipxreverseword(SOCKET_SERVIDOR);
	trama[0]=TRAMA_ABRIR;
	memcpy(&trama[1], hc.source.nodeadd, 6);
	ipxsendpacket(&ec);
	ipxrelenquishcontrol();
	delay(200);
}

/* ------------------------- Cierra conexin ------------------------------ */
void _fastcall cerrarc (void)
{
//	register unsigned char c;
//	register unsigned int i;
//	char tmp[3];
	char trama[80];

	ac.socket=ipxreverseword(SOCKET_CLIENTE);
	/* Le envamos al servido la peticin de apertura */
	memset(&hc, 0, sizeof(hc));
	memset(&hs, 0, sizeof(hs));
	memset(&ec, 0, sizeof(ec));
	memset(&es, 0, sizeof(es));
	ec.socket=ipxreverseword(SOCKET_CLIENTE);
	ec.fragcount=2;
	ec.fragaddr1=&hc;
	ec.fragsize1=sizeof(IPXHEADER);
	ec.fragaddr2=trama;
	ec.fragsize2=sizeof(trama);
	memset(hc.dest.nodeadd, 0xFF, 6);
	//for (i=0; i!=12; i+=2)
	//	hc.dest.nodeadd[i>>1]=0xF;
		//hc.dest.nodeadd[i>>1]=hex2int(&cad[i]);
	memcpy(&ec.immedaddr, &hc.dest.nodeadd, 6);
	hc.checksum=0xFFFF;
	hc.type=4;
	memset(hc.dest.netadd, 0, 4);
	hc.dest.socket=ipxreverseword(SOCKET_SERVIDOR);
	trama[0]=TRAMA_CERRAR;
	memcpy(&trama[1], hc.source.nodeadd, 6);
	ipxsendpacket(&ec);
	ipxrelenquishcontrol();
	delay(200);
	ipxclosesocket(ipxreverseword(SOCKET_CLIENTE));
}


/* ------------------------ Abre el servidor------------------------------- */
void _fastcall abrirs (char *cad)
{
	printf("Abierta conexin con el nodo %02X%02X%02X%02X:%02X%02X%02X%02X%02X%02X\n",
					hs.source.netadd[0], hs.source.netadd[1], hs.source.netadd[2],
					hs.source.netadd[3], hs.source.nodeadd[0], hs.source.nodeadd[1],
					hs.source.nodeadd[2], hs.source.nodeadd[3],	hs.source.nodeadd[4],
					hs.source.nodeadd[5]);
}

/* ------------------------- Cierra el servidor --------------------------- */
void _fastcall cerrars (void)
{
	printf("Cerrada conexin con el nodo %02X%02X%02X%02X:%02X%02X%02X%02X%02X%02X\n",
					hs.source.netadd[0], hs.source.netadd[1], hs.source.netadd[2],
					hs.source.netadd[3], hs.source.nodeadd[0], hs.source.nodeadd[1],
					hs.source.nodeadd[2], hs.source.nodeadd[3], hs.source.nodeadd[4],
					hs.source.nodeadd[5]);
	ipxclosesocket(ipxreverseword(SOCKET_SERVIDOR));
}

/* ------------------- Ejecuta un comando externo ------------------------- */
void _fastcall ejecutar (char *cad)
{
	register unsigned int i;

	i=system(cad);
	if (i!=0)
		puts("Imposible ejecutar comando externo");
}

void _fastcall ayudac (void)
{
	char cad[256];
	unsigned int fin=0;

	puts("");
	puts("Comandos disponibles:");
	puts("	OPEN/CONNECT");
	puts("	CLOSE/BYE");
	puts("	GET");
	puts("	PUT");
	puts("	RUN");
	puts("");
	puts("	Elige el comado del que quieres obtener la ayuda.");
	puts("	Escribe Quit o Exit para salir del Men de ayuda.");
	puts("");
	do
	{
		printf("$ HELP> ");
		gets(cad);
		strupr(cad);
		if ((memcmp(cad, "OPEN", 4)==0) || (memcmp(cad, "CONNECT", 4)==0))
		{
			puts("");
			puts("	OPEN/CONNECT <direccin>");
			puts("	Abre la conexin con el terminal proveedor de ficheros.");
			puts("	<direccin>: es la direccin dentro de la red NOVELL del terminal");
			puts("	             proveedor de archivos.");
			puts("");
		}
		else if ((memcmp(cad, "CLOSE", 3)==0) || (memcmp(cad, "BYE", 3)==0))
		{
			puts("");
			puts("	CLOSE/BYE");
			puts("	Cierra la conexin con el servidor de ficheros.");
			puts("");
		}
		else if (memcmp(cad, "GET", 3)==0)
		{
			puts("");
			puts("	GET <nombre>");
			puts("	Obtiene un fichero del servidor.");
			puts("	<nombre>: nombre del fichero que queremos recibir del proveedor de");
			puts("	          archivos.");
			puts("");
		}
		else if (memcmp(cad, "PUT", 3)==0)
		{
			puts("");
			puts("	PUT <nombre>");
			puts("	Enva un fichero al servidor.");
			puts("	<nombre>: nombre del fichero que queremos enviar al proveedor de");
			puts("	          archivos.");
			puts("");
		}
		else if (memcmp(cad, "RUN", 3)==0)
		{
			puts("");
			puts("	RUN <comando>");
			puts("	Ejecuta un comando del Sistema Operativo.");
			puts("	<comando>: nombre del comando que queremos ejecutar.");
			puts("");
		}
		else if ((memcmp(cad, "", 1)!=0) && (memcmp(cad, "QUIT", 4)!=0)
							&& (memcmp(cad, "EXIT", 4)!=0))
		{
			puts("No hay ayuda disponible acerca de este comando");
			puts("");
			puts("Comandos disponibles:");
			puts("	OPEN/CONNECT");
			puts("	CLOSE/BYE");
			puts("	GET");
			puts("	PUT");
			puts("	RUN");
			puts("");
			puts("	Elige el comado del que quieres obtener la ayuda.");
			puts("	Escribe Quit o Exit para salir del Men de ayuda.");
			puts("");
		}
		else
			fin=1;
	}
	while (!fin);
}

void _fastcall menu (void)
{
	char cad[256];

	puts("Actuando como CONEXION");
	do
	{
		printf("$ MENU_CONEXION> ");
		gets(cad);
		strupr(cad);
		if ((memcmp(cad, "SERVER", 5)==0) || (memcmp(cad, "HOST", 4)==0))
			servidor();
		else if ((memcmp(cad, "CLIENT", 5)==0) || (memcmp(cad, "STATION", 7)==0))
			cliente();
		else if ((memcmp(cad, "QUIT", 4)==0) || (memcmp(cad, "EXIT", 4)==0))
			salir(0);
		else if ((memcmp(cad, "HELP", 4)==0) || (memcmp(cad, "?", 1)==0))
			ayudam();
		else
			puts("Comando no reconocido");
	}
	while ((memcmp(cad, "QUIT", 4)!=0) && (memcmp(cad, "EXIT", 4)!=0));
}

void _fastcall ayudam (void)
{
	char cad[256];
	unsigned int fin=0;

	puts("");
	puts("Comandos disponibles:");
	puts("	SERVER/HOST");
	puts("	CLIENT/STATION");
	puts("");
	puts("	Elige el comado del que quieres obtener la ayuda.");
	puts("	Escribe Quit o Exit para salir del Men de ayuda.");
	puts("");
	do
	{
		printf("$ MENU_CONEXION> HELP> ");
		gets(cad);
		strupr(cad);
		if ((memcmp(cad, "SERVER", 3)==0) || (memcmp(cad, "HOST", 4)==0))
		{
			puts("");
			puts("	SERVER/HOST");
			puts("	Elige el modo servidor. En este modo el ordenador ser el anfitrin");
			puts("	de los archivos.");
			puts("");
		}
		else if ((memcmp(cad, "CLIENT", 3)==0) || (memcmp(cad, "STATION", 4)==0))
		{
			puts("");
			puts("	CLIENT/STATION");
			puts("	Elige el modo cliente. En este modo el ordenador ser el invitado");
			puts("	de los archivos.");
			puts("");
		}
		else if ((memcmp(cad, "", 1)!=0) && (memcmp(cad, "QUIT", 4)!=0)
							&& (memcmp(cad, "EXIT", 4)!=0))
		{
			puts("No hay ayuda disponible acerca de este comando");
			puts("");
			puts("Comandos disponibles:");
			puts("	SERVER/HOST");
			puts("	CLIENT/STATION");
			puts("");
			puts("	Elige el comado del que quieres obtener la ayuda.");
			puts("	Escribe Quit o Exit para salir del Men de ayuda.");
			puts("");
		}
		else
			fin=1;
	}
	while (!fin);
}

void _fastcall ponerc (char *cad)
{
	#define BUFTAM 512
	register unsigned int i;
	register unsigned int leidos;
	FILE *f;
	unsigned long llevo, total;
	clock_t start, stop;
	unsigned char buffer[BUFTAM];
	char trama[80+BUFTAM];

	printf("Enviando el fichero %s\n", cad);
	f=fopen(cad, "rb");
	if (f==0)
	{
		puts("Imposible abrir el fichero especificado");
		return;
	}
	/* Le envamos al servido la peticin de apertura */
	memset(&hc, 0, sizeof(hc));
	memset(&hs, 0, sizeof(hs));
	memset(&ec, 0, sizeof(ec));
	memset(&es, 0, sizeof(es));
	ec.socket=ipxreverseword(SOCKET_CLIENTE);
	ec.fragcount=2;
	ec.fragaddr1=&hc;
	ec.fragsize1=sizeof(IPXHEADER);
	ec.fragaddr2=&trama;
	ec.fragsize2=18;
	memset(&hc.dest.nodeadd, 0xFF, 6);
	memset(&ec.immedaddr, 0xFF, 6);
/*	for (i=0; i!=12; i+=2)
		hc.dest.nodeadd[i>>1]=hex2int(&cad[i]);
	memcpy(&ec.immedaddr, &hc.dest.nodeadd, 6); */
	hc.checksum=0xFFFF;
	hc.type=4;
	memset(hc.dest.netadd, 0, 4);
	hc.dest.socket=ipxreverseword(SOCKET_SERVIDOR);
	llevo=filelength(fileno(f));
	trama[0]=TRAMA_PONER;
	memcpy(&trama[1], cad, 13);
	memcpy(&trama[14], &llevo, 4);
	ipxsendpacket(&ec);
	ipxrelenquishcontrol();
	delay(200);
	llevo=0;
	start=clock();
	delay(100);
	do
	{
		leidos=fread(buffer, 1, BUFTAM, f);
		llevo+=leidos;
		/* Le envamos al servido la peticin de poner */
		memset(&hc, 0, sizeof(hc));
		memset(&hs, 0, sizeof(hs));
		memset(&ec, 0, sizeof(ec));
		memset(&es, 0, sizeof(es));
		ec.socket=ipxreverseword(SOCKET_CLIENTE);
		ec.fragcount=2;
		ec.fragaddr1=&hc;
		ec.fragsize1=sizeof(IPXHEADER);
		ec.fragaddr2=trama;
		ec.fragsize2=513;
		for (i=0; i!=12; i+=2)
			hc.dest.nodeadd[i>>1]=hex2int(&cad[i]);
		memcpy(&ec.immedaddr, &hc.dest.nodeadd, 6);
		hc.checksum=0xFFFF;
		hc.type=4;
		memset(hc.dest.netadd, 0, 4);
		hc.dest.socket=ipxreverseword(SOCKET_SERVIDOR);
		trama[0]=TRAMA_PONER;
		memcpy(&trama[1], buffer, leidos);
		ipxsendpacket(&ec);
		ipxrelenquishcontrol();
		delay(200);
		stop=clock();
		printf("\r%u Kb (%u Kb / Segundo)", (unsigned int) (llevo>>10), (unsigned int) (((llevo*18)>>10)/(stop-start)));
	}
	while (leidos==BUFTAM);
	fclose(f);
	printf("\r%u Kb (%u Kb / Segundo)\n", (unsigned int) (llevo>>10), (unsigned int) (((llevo*18)>>10)/(stop-start)));
}

void _fastcall cogerc (char *cad)
{
	#define BUFTAM 512
	register unsigned int leidos;
	FILE *f;
	unsigned long llevo, total;
	clock_t start, stop;
	unsigned char buffer[BUFTAM];

	f=fopen(cad, "wb");
	if (f==0)
	{
		puts("Imposible crear el fichero especificado");
		return;
	}
	/* Envar trama de recibir el fichero */
	printf("Recibiendo el fichero %s (%u Kb)\n", cad, (unsigned int) (filelength(fileno(f))>>10));
	llevo=0;
	start=clock();
	delay(100);
	do
	{
		/* Cdigo de recibir */
		leidos=fwrite(buffer, 1, BUFTAM, f);
		llevo+=leidos;
		stop=clock();
		printf("\r%u Kb (%u Kb / Segundo)", (unsigned int) (llevo>>10), (unsigned int) (((llevo*18)>>10)/(stop-start)));
	}
	while (leidos==BUFTAM);
	fclose(f);
	printf("\r%u Kb (%u Kb / Segundo)", (unsigned int) (llevo>>10), (unsigned int) (((llevo*18)>>10)/(stop-start)));
}

/* ------------------------ Abre el servidor------------------------------- */
void _fastcall poners (char *cad)
{
	register unsigned int leidos;
	FILE *f;
	unsigned long tam;
	unsigned long llevo;
	char nombre[13];
	unsigned char buffer[BUFTAM];
	unsigned char trama[BUFTAM+80];

	memcpy(&nombre, &cad[0], 13);
	memcpy(&tam, &cad[13], 4);

	printf("Recibiendo el fichero %s (%ld bytes)\n", nombre, tam);

	f=fopen(nombre, "wb");
	llevo=0;
	do
	{
		memset(&hc, 0, sizeof(hc));
		memset(&hs, 0, sizeof(hs));
		memset(&ec, 0, sizeof(ec));
		memset(&es, 0, sizeof(es));
		es.inuse=0x1D;
		es.socket=ipxreverseword(SOCKET_SERVIDOR);
		es.fragcount=2;
		es.fragaddr1=&hs;
		es.fragsize1=sizeof(IPXHEADER);
		es.fragaddr2=trama;
		es.fragsize2=BUFTAM+1;
		ipxlistenforpacket(&es);
		while (es.inuse!=0)
		{
			ipxrelenquishcontrol();
		}
		llevo+=BUFTAM;
		fwrite(&trama[1], 1, BUFTAM, f);
		printf("%ld, %ld\n", llevo, tam);
	}
	while (llevo<tam);
	fclose(f);
}

void _fastcall cogers (char *cad)
{
}
